/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.base;

import java.sql.SQLException;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dto.MosPConfDto;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.PrefectureUtil;
import jp.mosp.payroll.bonus.dao.PhBounsDao;
import jp.mosp.payroll.bonus.dao.PmDetailBaDao;
import jp.mosp.payroll.bonus.dao.PmDetailBdDao;
import jp.mosp.payroll.bonus.dao.PmDetailBsDao;
import jp.mosp.payroll.bonus.dto.PhBounsDto;
import jp.mosp.payroll.bonus.dto.PmDetailBaDto;
import jp.mosp.payroll.bonus.dto.PmDetailBdDto;
import jp.mosp.payroll.bonus.dto.PmDetailBsDto;
import jp.mosp.payroll.dao.CdSocInsuranceDao;
import jp.mosp.payroll.dao.CmMidwayEnterDao;
import jp.mosp.payroll.dao.CmSocInsuranceDao;
import jp.mosp.payroll.dao.PdPayAllowanceDao;
import jp.mosp.payroll.dao.PdPayDeductionDao;
import jp.mosp.payroll.dao.PdPayTimeDao;
import jp.mosp.payroll.dao.PhPaymentDao;
import jp.mosp.payroll.dao.PmDetailPaDao;
import jp.mosp.payroll.dao.PmDetailPdDao;
import jp.mosp.payroll.dao.PmDetailPsDao;
import jp.mosp.payroll.dao.PmDetailPtDao;
import jp.mosp.payroll.dto.CdSocInsuranceDto;
import jp.mosp.payroll.dto.CmMidwayEnterDto;
import jp.mosp.payroll.dto.CmSocInsuranceDto;
import jp.mosp.payroll.dto.DetailMoneyDto;
import jp.mosp.payroll.dto.DetailPaDto;
import jp.mosp.payroll.dto.DetailPdDto;
import jp.mosp.payroll.dto.DetailTimeDto;
import jp.mosp.payroll.dto.PhPaymentDto;

/**
 * @author koike
 *
 */
public abstract class CalculateAction extends AttendanceTotalAction {
	
//	
//	// tB[h
	// vZsCX^X
//	protected UdPaymentDto udPaymentDto;	// Ώۋ^f[^
	PdPayAllowanceDao						pdPayAllowanceDao;															// Ώۋ^(׎x)f[^
	PdPayDeductionDao						pdPayDeductionDao;															// Ώۋ^(׍T)f[^
	// vZsCX^X(ܗ^)
//	protected UdBonusDto udBonusDto;	// Ώۏܗ^f[^
//	// ʌvZpϐ
	
	//	private   int taxFree     = 0;	// ېŊz
//	private   int socInsFree  = 0;	// ЉیΏۊz
//	protected int bank1Amount = 0;	// s1Uz
	
	//	protected int bank2Amount = 0;	// s2Uz
//	protected int cashAmount  = 0;	// xz
	// אݒ()
	/**
	 * 
	 */
	protected Map<String, DetailPaDto>		mapDetailAllPa;
	/**
	 * 
	 */
	protected Map<String, DetailPdDto>		mapDetailAllPd;
	/**
	 * 
	 */
	protected Map<String, DetailMoneyDto>	mapDetailAllPs;
	/**
	 * 
	 */
	protected Map<String, DetailTimeDto>	mapDetailAllPt;
	
	//	// vZݒ()
//	protected Map<String, Map<String, CsExpressionDto>> mapExpressAll;
	
	//	// אݒ(ܗ^)
	/**
	 * 
	 */
	protected Map<String, PmDetailBaDto>	mapDetailAllBa;
	/**
	 * 
	 */
	protected Map<String, PmDetailBdDto>	mapDetailAllBd;
	/**
	 * 
	 */
	protected Map<String, PmDetailBsDto>	mapDetailAllBs;
	
	// Џ()
	/**
	 * 
	 */
	protected float							ratioHealthPremium		= 0;												// Nی 
	/**
	 * 
	 */
	protected float							ratioNursingPremium		= 0;												// ی
	/**
	 * 
	 */
	protected float							ratioPensionPremium		= 0;												// N
	/**
	 * 
	 */
	protected float							ratioFundPremium		= 0;												// N
	/**
	 * 
	 */
	protected float							ratioUnemployPremium	= 0;												// ٗpی
	/**
	 * 
	 */
	protected String						fundParticipation		= "";												// N
																														
	/**
	 * Pݒ()
	 */
	protected Map<String, String>			mapFamilyAllowance;														// }{蓖P
																														
	/**
	 * ݒ()
	 */
	protected int							familyAllowanceLimit	= 0;												// }{蓖xΓ
//	// אݒMAP
//	Map<String, UsDetailDto> mapPaymentDetail;
//	// ^x(UD_PAYMENTp)
//	protected Date payDay;
//	
	protected Date							startDateOfYear;															// NJn
	protected Date							lastDateOfYear;															// NŏI
																														
	protected int							befkotei				= 0;
	protected int							nowkotei				= 0;
	
	protected int							befhikotei				= 0;
	protected int							nowhikotei				= 0;
	
	// ^Vz
	protected int							oldPremium				= 0;
	
	// ^Nی
	Date									oldHealthDate			= null;
	protected int							oldHealthPremium		= 0;
	
	// ^ی
	Date									oldNursingDate			= null;
	protected int							oldNursingPremium		= 0;
	
	// ^Nی
	Date									oldoldPensionDate		= null;
	protected int							oldPensionPremium		= 0;
	
	// ^Nی
	Date									oldFundDate				= null;
	protected int							oldFundPremium			= 0;
	
	// ^Љیz
	Date									oldSocInsDate			= null;
	protected int							oldSocInsPremium		= 0;
	
//	// ܗ^Ώ۔NNی(ΏۓȊO)
//	protected int befHealthPremium   = 0;
//	// ܗ^Ώ۔Nی(ΏۓȊO)
//	protected int befNursingPremium  = 0;
//	// ܗ^Ώ۔NNی(ΏۓȊO)
//	protected int befPensionPremium  = 0;
//	// ܗ^Ώ۔NNی(ΏۓȊO)
//	protected int befFundPremium     = 0;
//	// ܗ^Ώ۔NЉیz(ΏۓȊO)
//	protected int befSocInsPremium = 0;
//	
	// Љی
	protected int[]							arySocInsGrade			= { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14,
		15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42,
		43, 44, 45, 46, 47											};
	// WVz
	protected int[]							aryStandardPayment		= { 58000, 68000, 78000, 88000, 98000, 104000,
		110000, 118000, 126000, 134000, 142000, 150000, 160000, 170000, 180000, 190000, 200000, 220000, 240000, 260000,
		280000, 300000, 320000, 340000, 360000, 380000, 410000, 440000, 470000, 500000, 530000, 560000, 590000, 620000,
		650000, 680000, 710000, 750000, 790000, 830000, 880000, 930000, 980000, 1030000, 1090000, 1150000, 1210000 };
	// Vzz
	protected int[]							aryPaymentOver			= { 0, 63000, 73000, 83000, 93000, 101000, 107000,
		114000, 122000, 130000, 138000, 146000, 155000, 165000, 175000, 185000, 195000, 210000, 230000, 250000, 270000,
		290000, 310000, 330000, 350000, 370000, 395000, 425000, 455000, 485000, 515000, 545000, 575000, 605000, 635000,
		665000, 695000, 730000, 770000, 810000, 855000, 905000, 955000, 1005000, 1055000, 1115000, 1175000 };
	// Vzz
	protected int[]							aryPaymentUnder			= { 63000, 73000, 83000, 93000, 101000, 107000,
		114000, 122000, 130000, 138000, 146000, 155000, 165000, 175000, 185000, 195000, 210000, 230000, 250000, 270000,
		290000, 310000, 330000, 350000, 370000, 395000, 425000, 455000, 485000, 515000, 545000, 575000, 605000, 635000,
		665000, 695000, 730000, 770000, 810000, 855000, 905000, 955000, 1005000, 1055000, 1115000, 11750000, 0 };
	
	/**
	 * 
	 */
	protected CdSocInsuranceDao				cdSocInsuranceDao;															// ЉیvZf[^	
	/**
	 * 
	 */
	protected CdSocInsuranceDto				cdSocInsuranceDto;															// ЉیvZf[^
																														
	/**
	 * 
	 */
	protected PhPaymentDto					phSocInsPayment;
	
	static String[][]						aryPrefecture			= PrefectureUtil.getPrefectureArray();
	

//	
//	private String[][] aryRatioOvertime     ;
//	private String[][] aryRatioLateNight    ;
//	private String[][] aryRatioWorkOnHoliday;
//	
//	//@ỎېőΏۊz擾pN
//	Date befTargetMonth;
//	
//	
//	/**
//	 * vZmF
//	 * @param date Ώ۔N
//	 * @throws Exception 
//	 */
//	protected void checkCalcCurrent(Date date) throws Exception {
//		if (getCalcCurrent().compareTo(date) != 0) {
//			String errMessage = MospUtility.getMessage(msg, UnicConst.MSG_NOT_CURRENT, "");
//			addErrMessage(errMessage);
//			throw new MospException(UnicConst.EX_NOT_CURRENT, errMessage);
//		}
//	}
//	
//	/**
//	 * vZmF(vZNȍ~)
//	 * @param date Ώ۔N
//	 * @throws Exception 
//	 */
//	protected void checkCalcCurrentAfter(Date date) throws Exception {
//		if (getCalcCurrent().compareTo(date) > 0) {
//			String errMessage = MospUtility.getMessage(msg, UnicConst.MSG_NOT_CURRENT, "");
//			addErrMessage(errMessage);
//			throw new MospException(UnicConst.EX_NOT_CURRENT, errMessage);
//		}
//	}
//	
//	/**
//	 * ^vZ(ΑӋyѐl񂩂擾\ȏ̂ݐݒ)
//	 * @throws Exception
//	 */
//	protected void calcPayment() throws Exception {
//		// ΑӃf[^擾
//		getAttendanceList(kCode, targetMonth);
//		// Wvf[^擾
//		getAttendanceDaily();
//		// Wvf[^ʎԐݒ
//		setEffort();
//		// Wvf[^Ԑݒ
//		setHours();
//		// Wvf[^t蓖ݒ
//		setDateAllowance();
//		// Wv
//		attendanceMonthlyDto = totalAttendanceDaily();
//		// אݒ菉
//		setDetailData();
//		// Abv[hf[^ݒ(^f[^ɑ݂ꍇ)
//		setUploadedData();
//		// zAEzݒmF
//		chkCutAmount();
//		// ^f[^ݒ
//		// ({AE\蓖AԊO蓖A}{蓖AʋΔAP)
//		setPaymentData();
//		// vZɂvZ
//		calcExpression();
//		// ^xݒ
//		attendanceMonthlyDto.setPayday(payDay);
//		// Xe[^Xݒ(f[^쐬)
//		attendanceMonthlyDto.setCalcStatus(UnicConst.CALC_STATUS_CRE);
//	}
//
//	/**
//	 * אݒ擾
//	 * @throws NoSuchFieldException 
//	 * @throws IllegalAccessException 
//	 * @throws SQLException 
//	 */
//	protected void setDetailData() throws SQLException, IllegalAccessException, NoSuchFieldException {
//		udPaymentDto = new PhPaymentDto();
//		udPaymentDto.setKCode(attendanceMonthlyDto.getKCode());
//		udPaymentDto.setEmploymentType(attendanceMonthlyDto.getEmploymentType());
//		udPaymentDto.setPositionCode(attendanceMonthlyDto.getPositionCode());
//		mapPaymentDetail = getMapDetail();
//	}
//
//	/**
//	 * EzA{zݒ
//	 * @throws NoSuchFieldException 
//	 * @throws IllegalAccessException 
//	 * @throws SQLException 
//	 */
//	protected void chkCutAmount() {
//		// FΌzݒmF
//		UsDetailDto usDetailDto = mapPaymentDetail.get(UnicConst.DTL_PAY_ALLOWANCE_07);
//		if (usDetailDto == null) {
//			// FΌz0~ɐݒ
//			attendanceMonthlyDto.setCutForMissing(0);
//		}
//		// EzݒmF
//		usDetailDto = mapPaymentDetail.get(UnicConst.DTL_PAY_ALLOWANCE_08);
//		if (usDetailDto == null) {
//			// Ez0~ɐݒ
//			attendanceMonthlyDto.setCutForShort(0);
//		}
//		// {zݒmF
//		usDetailDto = mapPaymentDetail.get(UnicConst.DTL_PAY_ALLOWANCE_20);
//		// vZЈɖאݒ肪݂Ȃꍇ
//		if (usDetailDto == null) {
//			// {z0~ɐݒ
//			attendanceMonthlyDto.setCutFromBasic(0);
//		}
//	}
//	
//	/**
//	 * @TvZ(Љیyѐŋ̐ݒ)
//	 * @throws Exception
//	 */
//	protected void calcLegalDeduction() throws Exception {
//		// אݒɂzvZ(ېŊzyюЉیΏۊz)
//		calcFreeAmount();
//		// ЉیΏۊzݒ
//		udPaymentDto.setAmountToSocIns(
//				udPaymentDto.calcAllowanceTotal() - socInsFree);
//		// Љیݒ
//		setSocialInsurance();
//		// ېőΏۊzݒ
//		int taxation = udPaymentDto.calcAllowanceTotal() -
//				udPaymentDto.calcSocialInsurance() -
//				taxFree - udPaymentDto.getCommutationFree();
//		udPaymentDto.setAmountToTaxation(taxation > 0 ? taxation : 0);
//				
//		// Őݒ
//		setIncomeTax();
//		// ZŐݒ
//		setResidenceTax();
//		// m荀ڏ
//		udPaymentDto.setAllowanceTotal(0);
//		udPaymentDto.setDeductionTotal(0);
//		udPaymentDto.setPaymentTotal  (0);
//		udPaymentDto.setBank1PayAmount(0);
//		udPaymentDto.setBank2PayAmount(0);
//		udPaymentDto.setCashPayAmount (0);
//		// Xe[^Xݒ(ŋvZς)
//		udPaymentDto.setCalcStatus(UnicConst.CALC_STATUS_TAX);
//	}
//	
	/**
	 * mvZ(vyыsU)
	 * @throws Exception
	 */
	protected void calcTotal(boolean needCalcIncomeTax) throws Exception {
		// אݒɂzvZ(ېŊzyюЉیΏۊz)
//		calcFreeAmount();
		// ېőΏۊzݒ
//		int taxation = udPaymentDto.calcAllowanceTotal() -
//				udPaymentDto.calcSocialInsurance() -
//				taxFree - udPaymentDto.getCommutationFree();
//		udPaymentDto.setAmountToTaxation(taxation > 0 ? taxation : 0);
		// ŌvZ
//		if (needCalcIncomeTax) {
//			setIncomeTax();
//		}
		// vvZ
//		int allowance = 0;	// xz
//		int deduction = 0;	// Tz
//		int total     = 0;	// xz
		// xz擾
//		allowance = udPaymentDto.calcAllowanceTotal();
		// Tz擾
//		deduction = udPaymentDto.calcDeductionTotal();
		// xzvZ(xz-Tz)
//		total = allowance - deduction; 
		// sU
//		divideAmongAccounts(total, UnicConst.ALLOWANCE_TYPE_SALARY);
		// mݒ
//		udPaymentDto.setAllowanceTotal(allowance  );
//		udPaymentDto.setDeductionTotal(deduction  );
//		udPaymentDto.setPaymentTotal  (total      );
		// xz}CiX̏ꍇ͋s1As2A̒l0ɐݒ肷
//		if (total < 0) {
//			udPaymentDto.setBank1PayAmount(0);
//			udPaymentDto.setBank2PayAmount(0);
//			udPaymentDto.setCashPayAmount (total);
//		} else {
//			udPaymentDto.setBank1PayAmount(bank1Amount);
//			udPaymentDto.setBank2PayAmount(bank2Amount);
//			udPaymentDto.setCashPayAmount (cashAmount );
//		}
		// Xe[^Xݒ(m菈ς)
//		udPaymentDto.setCalcStatus(UnicConst.CALC_STATUS_FIX);
	}
	
	/**
	 * mvZ(vyыsU)(ܗ^)
	 * @throws Exception
	 */
	protected void calcBonusTotal() throws Exception {
//		// Őݒ
//		setBonusIncomeTax();
//		// mvZ
//		int allowance = 0;	// xz
//		int deduction = 0;	// Tz
//		int total     = 0;	// xz
//		// xz擾
//		allowance = udBonusDto.calcBonusAllowanceTotal();
//		// Tz擾
//		deduction = udBonusDto.calcBonusDeductionTotal();
//		// xzvZ(xz-Tz)
//		total = allowance - deduction; 
//		// sU
//		divideAmongAccounts(total, UnicConst.ALLOWANCE_TYPE_BONUS);
//		// mݒ
//		udBonusDto.setAllowanceTotal(allowance  );
//		udBonusDto.setDeductionTotal(deduction  );
//		udBonusDto.setPaymentTotal  (total      );
//		// xz}CiX̏ꍇ͋s1As2A̒l0ɐݒ肷
//		if (total < 0) {
//			udBonusDto.setBank1PayAmount(0);
//			udBonusDto.setBank2PayAmount(0);
//			udBonusDto.setCashPayAmount (total);
//		} else {
//			udBonusDto.setBank1PayAmount(bank1Amount);
//			udBonusDto.setBank2PayAmount(bank2Amount);
//			udBonusDto.setCashPayAmount (cashAmount );
//		}
//		// Xe[^Xݒ(m菈ς)
//		udBonusDto.setCalcStatus(UnicConst.CALC_STATUS_FIX);
	}
	
//	/**
//	 * x(xl)擾
//	 * @param targetMonth Ώ۔N
//	 * @throws NoSuchFieldException 
//	 * @throws IllegalAccessException 
//	 * @throws SQLException 
//	 * @throws MospException 
//	 */
//	public Date getPayDay(
//			Date targetMonth
//	) throws SQLException, IllegalAccessException, NoSuchFieldException, MospException {
//		// 擾
//		Date payDay = null;
//		Calendar payCal = Calendar.getInstance();
//		// Ώ۔NJ_[ɐݒ
//		payCal.setTime(targetMonth);
//		// Conf擾xAxԊuݒ肵x擾
//		payDay = setSettingPaymentDate(payCal);
//		// xmF
//		while (!chkDateHoliday(payDay).equals("")){
//			// x̏ꍇ͎x}CiX1čĂъmF
//			payCal.add(Calendar.DATE, -1);
//			payDay = payCal.getTime();
//		}
//		// x̐ݒ(xl)
//		return payDay;
//	}
//	
//	/**
//	 * xmF
//	 * @param targetDate@Ώ۔N
//	 * @return x̖
//	 * @throws MospException
//	 */
//	private String chkDateHoliday(Date targetDate) throws MospException {
//		// mF
//		Calendar targetCal = Calendar.getInstance();
//		String holidayName = "";
//		// mF̂߃J_[ɐݒ
//		targetCal.setTime(targetDate);
//		// jmF
//		holidayName = chkLegalHoliday(targetDate);
//		if (holidayName.equals("")) {
//			// Ώۓ̋x
//			holidayName = chkNationHoliday(targetDate);
//			if (holidayName.equals("")) 
//			{
//				// ΏۓU֋x
//				holidayName = chkTransferHoliday(targetDate);
//			} else {
//				return holidayName;
//			}
//		}
//		if (holidayName.equals("")) {
//			if (targetCal.get(Calendar.DAY_OF_WEEK) == Calendar.SATURDAY) {
//				// Ώۓyj
//				holidayName = "y";
//			}
//			if  (targetCal.get(Calendar.DAY_OF_WEEK) == Calendar.SUNDAY) {
//				// Ώۓj
//				holidayName = "";
//			}
//		} else {
//			return holidayName;
//
//		}
//		return holidayName;
//	}
//	
//	/**
//	 * jmF
//	 * @param targetDate@Ώ۔N
//	 * @return@j
//	 * @throws MospException
//	 */
//	private String chkNationHoliday(Date targetDate) throws MospException {
//		// vZ
//		String holidayName = "";
//		Calendar targetCal = Calendar.getInstance();
//		// Ώۓ̑O擾
//		targetCal.setTime(targetDate);
//		targetCal.add(Calendar.DATE, 1);
//		Date befTargetDate = targetCal.getTime();
//		// Ώۓ̌擾
//		targetCal.setTime(targetDate);
//		targetCal.add(Calendar.DATE, -1);
//		Date aftTargetDate = targetCal.getTime();
//		// O̓xłȂ΍̋xł͂Ȃ
//		if (!chkLegalHoliday(befTargetDate).equals("")) {
//			// ̓Ȃ獑̋xł͂Ȃ
//			if (chkLegalHoliday(aftTargetDate).equals("")) {
//				holidayName = "";
//			} else {
//				// Ώۓ̑OA̓x̏ꍇ̂ݍ̋xKp
//				holidayName = "̋x";
//			}
//		} else {
//			holidayName = "";
//		}
//		return holidayName;
//	}
//
//	/**
//	 * U֋xmF
//	 * @param targetDate@Ώ۔N
//	 * @return@j
//	 * @throws MospException
//	 */
//	private String chkTransferHoliday(Date targetDate) throws MospException {
//		// vZ
//		String holidayName = "";
//		Calendar targetCal = Calendar.getInstance();
//		targetCal.setTime(targetDate);
//		// ΏۏT擾
//		int targetWeek =  targetCal.get(Calendar.DAY_OF_WEEK_IN_MONTH);
//		// ΏۏT̓jxf
//		targetCal.set(Calendar.DAY_OF_WEEK_IN_MONTH, targetWeek);
//		targetCal.set(Calendar.DAY_OF_WEEK, Calendar.SUNDAY);
//		holidayName =  chkLegalHoliday(targetCal.getTime());
//		
//		while (!holidayName.equals("")) {
//			targetCal.add(Calendar.DATE, 1);
//			holidayName = chkLegalHoliday(targetCal.getTime());
//		}
//		
//		if (targetCal.getTime().compareTo(targetDate) == 0) {
//			holidayName = "U֋x";
//		} else {
//			holidayName = "";
//		}
//			
//		
//		return holidayName;
//		
//	}
//	
//	/**
//	 * jmF
//	 * @param targetDate@Ώ۔N
//	 * @return@j
//	 * @throws MospException
//	 */
//	private String chkLegalHoliday(Date targetDate) throws MospException {
//		String legalHolidayName = "";
//		// jz擾(w肵N̏j)
//		LegalHolidayUtility legalHolidayUtility = new LegalHolidayUtility(MospUtility.getYear(targetDate));
//		String [][] aryHoliday = legalHolidayUtility.getArySyuku();
//		// Ώۓj
//		for (int i= 0; i < aryHoliday.length; i++) {
//			// tmF̂StringDate
//			Date holiday = MospUtility.getDate(aryHoliday[i][0]);
//			if (holiday.compareTo(targetDate) == 0) {
//				// tv疼̂Ԃ
//				legalHolidayName = aryHoliday[i][1];
//				break;
//			}
//		}
//		
//		return legalHolidayName;
//	}
//	
//	/**
//	 * ݒx擾
//	 * @param payCal@Ώ۔N(J_[)
//	 * @return@ݒx
//	 * @throws SQLException
//	 * @throws IllegalAccessException
//	 * @throws NoSuchFieldException
//	 */
//	private Date setSettingPaymentDate(Calendar payCal)  throws SQLException, IllegalAccessException, NoSuchFieldException{
//		// Ԋҏ
//		Date payDay = null;
//		// CONFe[uxƎxԊu擾
//		String[][] aryPayDay      = getConfArray(UnicConst.CONF_ID_PAY_DAY);
//		String[][] aryPayInterval = getConfArray(UnicConst.CONF_ID_PAY_ITBL);
//		
//		payCal.add(Calendar.MONTH, Integer.parseInt(aryPayInterval[0][1]));
//		payCal.set(Calendar.DATE, Integer.parseInt(aryPayDay[0][1]));
//		payDay = payCal.getTime();
//		
//		return payDay;
//		
//		
//		
//	}
//	/**
//	 * ^f[^ݒ({AE\蓖AԊO蓖A}{蓖AʋΔAP)
//	 * @throws Exception 
//	 */
//	private void setPaymentData() throws Exception {
//		// DAO
//		CmCommutationDao    cmCommutationDao    = new CmCommutationDao   ();
//		CmUnitAmountDao     cmUnitAmountDao     = new CmUnitAmountDao    ();
//		UsAbiliAllowanceDao usAbiliAllowanceDao = new UsAbiliAllowanceDao();
//		cmCommutationDao   .initDao(cfg, cmd, aspUser, user, conn);
//		cmUnitAmountDao    .initDao(cfg, cmd, aspUser, user, conn);
//		usAbiliAllowanceDao.initDao(cfg, cmd, aspUser, user, conn);
//		// {ݒ
//		setBasicSalary();
//		// E\蓖1ݒ
//		attendanceMonthlyDto.setAbility1Allowance(uhIndividualDto.getAbilityAllowance());
//		// E\蓖2ݒ
//		attendanceMonthlyDto.setAbility2Allowance(uhIndividualDto.getAbilityAllowance2());
//		// Pݒ
//		List<CmUnitAmountDto> listUnitAmount = cmUnitAmountDao.findForEmployee(kCode);
//		setUnitAmount(listUnitAmount);
//		// ʋΔݒ
//		setCmCommutationAmount(cmCommutationDao.findForEmployee(kCode));
//		// ԊO蓖ݒ
//		setOvertimeAllowance(listUnitAmount);
//		// }{蓖ݒ
//		setFamilyAllowance();
//	}
//	
//	/**
//	 * vZPݒ
//	 * @param listUnitAmount P񃊃Xg
//	 */
//	private void setUnitAmount(List<CmUnitAmountDto> listUnitAmount) {
//		for (Iterator<CmUnitAmountDto> it = listUnitAmount.iterator(); it.hasNext();) {
//			CmUnitAmountDto dto = it.next();
//			int ceilAmount  = (int)round(dto.getUnitAmount(), 0, BigDecimal.ROUND_CEILING);
//			int floorAmount = (int)round(dto.getUnitAmount(), 0, BigDecimal.ROUND_FLOOR  );
//			if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_05)) {
//				attendanceMonthlyDto.setAllowance_05(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_06)) {
//				attendanceMonthlyDto.setAllowance_06(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_09)) {
//				attendanceMonthlyDto.setAllowance_09(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_10)) {
//				attendanceMonthlyDto.setAllowance_10(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_11)) {
//				attendanceMonthlyDto.setAllowance_11(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_12)) {
//				attendanceMonthlyDto.setAllowance_12(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_13)) {
//				attendanceMonthlyDto.setAllowance_13(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_15)) {
//				attendanceMonthlyDto.setAllowance_15(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_16)) {
//				attendanceMonthlyDto.setAllowance_16(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_ALLOWANCE_17)) {
//				attendanceMonthlyDto.setAllowance_17(ceilAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_08)) {
//				attendanceMonthlyDto.setDeduction_08(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_09)) {
//				attendanceMonthlyDto.setDeduction_09(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_10)) {
//				attendanceMonthlyDto.setDeduction_10(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_11)) {
//				attendanceMonthlyDto.setDeduction_11(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_12)) {
//				attendanceMonthlyDto.setDeduction_12(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_13)) {
//				attendanceMonthlyDto.setDeduction_13(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_14)) {
//				attendanceMonthlyDto.setDeduction_14(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_15)) {
//				attendanceMonthlyDto.setDeduction_15(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_16)) {
//				attendanceMonthlyDto.setDeduction_16(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_17)) {
//				attendanceMonthlyDto.setDeduction_17(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_18)) {
//				attendanceMonthlyDto.setDeduction_18(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_19)) {
//				attendanceMonthlyDto.setDeduction_19(floorAmount);
//			} else if (needUnitAmount(dto, UnicConst.DTL_PAY_DEDUCTION_20)) {
//				attendanceMonthlyDto.setDeduction_20(floorAmount);
//			}
//		}
//	}
//	
//	private boolean needUnitAmount(CmUnitAmountDto dto, String unitType) {
//		if (dto.getUnitType().equals(unitType) && dto.getUnitAmount() != 0D) {
//			return true;
//		}
//		return false;
//
//	}
//	
//	/**
//	 * {ݒ肷B<br>
//	 */
//	private void setBasicSalary() {
//		// {擾
//		int basicSalary = uhIndividualDto.getBasicSalary();
//		// 
//		if (uhIndividualDto.getPaymentType().equals(UnicConst.PAYMENT_PER_HOUR)) {
//			// { * oΎ(2008.10.02 쓇 C)
//			basicSalary = (int)round(basicSalary * attendanceMonthlyDto.getPaymentHours(),0 , BigDecimal.ROUND_HALF_UP);
//		} else if (uhIndividualDto.getPaymentType().equals(UnicConst.PAYMENT_PER_DAY)) {
//			// 
//			basicSalary = basicSalary * (attendanceMonthlyDto.getPresence()
//					+ attendanceMonthlyDto.getWorkOnHoliday()
//					+ attendanceMonthlyDto.getParticularHoliday()
//					+ attendanceMonthlyDto.getPaidHoliday());
//		}
//		attendanceMonthlyDto.setBasicSalary(basicSalary);
//	}
//
//	
//	/**
//	 * ԊO擾
//	 * @throws NoSuchFieldException 
//	 * @throws IllegalAccessException 
//	 * @throws SQLException 
//	 */
//	private void setOvertimeRatio(
//			) throws SQLException, IllegalAccessException, NoSuchFieldException {
//		// 擾ϊmF
//		if (aryRatioOvertime != null) {
//			return;
//		}
//		// UM_CONFl擾
//		aryRatioOvertime      = getConfArray(UnicConst.CONF_ID_RATIO_OT);
//		aryRatioLateNight     = getConfArray(UnicConst.CONF_ID_RATIO_LN);
//		aryRatioWorkOnHoliday = getConfArray(UnicConst.CONF_ID_RATIO_WH);
//	}
//	
//	/**
//	 * Abv[hڐݒ
//	 * @throws NoSuchFieldException 
//	 * @throws IllegalAccessException 
//	 * @throws SQLException 
//	 */
//	private void setUploadedData(
//	) throws SQLException, IllegalAccessException, NoSuchFieldException {
//		// DAO
//		PhPaymentDao dao = new PhPaymentDao();
//		dao.initDao(cfg, cmd, aspUser, user, conn);
//		// ^f[^擾
//		PhPaymentDto dto = dao.findForKey(kCode, targetMonth);
//		if (dto == null) {
//			return;
//		}
//		// Abv[hڐݒ
//		attendanceMonthlyDto.setAllowance_05(dto.getAllowance_05());
//		attendanceMonthlyDto.setAllowance_09(dto.getAllowance_09());
//		attendanceMonthlyDto.setAllowance_10(dto.getAllowance_10());
//		attendanceMonthlyDto.setAllowance_11(dto.getAllowance_11());
//		attendanceMonthlyDto.setAllowance_12(dto.getAllowance_12());
//		attendanceMonthlyDto.setAllowance_13(dto.getAllowance_13());
//		attendanceMonthlyDto.setAllowance_15(dto.getAllowance_15());
//		attendanceMonthlyDto.setAllowance_16(dto.getAllowance_16());
//		attendanceMonthlyDto.setAllowance_17(dto.getAllowance_17());
//		attendanceMonthlyDto.setDeduction_08(dto.getDeduction_08());
//		attendanceMonthlyDto.setDeduction_09(dto.getDeduction_09());
//		attendanceMonthlyDto.setDeduction_10(dto.getDeduction_10());
//		attendanceMonthlyDto.setDeduction_12(dto.getDeduction_12());
//		attendanceMonthlyDto.setDeduction_13(dto.getDeduction_13());
//	}
//	
//	/**
//	 * ݒl擾(float)
//	 * @return ݒl(float)
//	 */
//	private float getConfValueFloat(String[][] aryConf, String confId) {
//		float confValue = 0F;
//		if (aryConf == null) {
//			return confValue;
//		}
//		for (int i = 0; i < aryConf.length; i++) {
//			if (aryConf[i][0].equals(confId)) {
//				return Float.parseFloat(aryConf[i][1]);
//			}
//		}
//		return confValue;
//	}
//	
//	/**
//	 * ԒP擾B<br>
//	 * @return ԒP
//	 * @throws NoSuchFieldException 
//	 * @throws IllegalAccessException 
//	 * @throws SQLException 
//	 * @throws ClassNotFoundException 
//	 * @throws Exception 
//	 */
//	protected float getAmountPerHour() throws ClassNotFoundException, SQLException, IllegalAccessException, NoSuchFieldException {
//		// ԒP擾
//		setHoursPerDay();
//		setPrescribedCalendar();
//		float amountPerHour = 0F;
//		if (uhIndividualDto.getPaymentType().equals(UnicConst.PAYMENT_PER_MONTH)) {
//			amountPerHour = (
//					uhIndividualDto.getBasicSalary      () +
//					uhIndividualDto.getAbilityAllowance () +
//					uhIndividualDto.getAbilityAllowance2()
//					) / (prescribedDays * hoursPerDay);
//		} else if (uhIndividualDto.getPaymentType().equals(UnicConst.PAYMENT_PER_DAY)) {
//			amountPerHour = uhIndividualDto.getBasicSalary() / hoursPerDay;
//		} else if (uhIndividualDto.getPaymentType().equals(UnicConst.PAYMENT_PER_HOUR)) {
//			amountPerHour = uhIndividualDto.getBasicSalary();
//		}
//		return amountPerHour;
//	}
//	
//	/**
//	 * ԊO蓖vZ
//	 * @return ԊO蓖
//	 * @throws NoSuchFieldException 
//	 * @throws IllegalAccessException 
//	 * @throws SQLException 
//	 * @throws ClassNotFoundException 
//	 */
//	private void setOvertimeAllowance(
//			List<CmUnitAmountDto> listUnitAmount
//	) throws ClassNotFoundException, SQLException, IllegalAccessException, NoSuchFieldException {
//		// ftHgJԁAԊO擾
//		setHoursPerDay();
//		setOvertimeRatio();
//		// ԒP擾
//		float amountPerHour = getAmountPerHour();
//		// cƁAʎ蓖
//		double effortAllowance = 0D;
//		// P擾
//		Float effortUnit = getUnitRatio(listUnitAmount, UnicConst.UNIT_OVERTIME);
//		// P݂Ȃꍇ
//		if (effortUnit == null) {
//			// P =  * ԒP
//			effortUnit = new Float(getConfValueFloat(
//					aryRatioOvertime, uhIndividualDto.getPaymentType()) * amountPerHour);
//		}
//		if (attendanceMonthlyDto.getEffortTime() > 0) {
//			// cƁAʎ蓖 = cƁAʎ * P
//			effortAllowance = attendanceMonthlyDto.getEffortTime() * effortUnit.floatValue();
//		}
//		attendanceMonthlyDto.setEffortUnit(effortUnit.floatValue());
//		attendanceMonthlyDto.setEffortAllowance(
//				(int)round(effortAllowance, 0, BigDecimal.ROUND_CEILING));
//		// [蓖
//		double lateNightAllowance = 0D;
//		// P擾
//		Float lateNightUnit = getUnitRatio(listUnitAmount, UnicConst.UNIT_LATE_NIGHT);
//		// P݂Ȃꍇ
//		if (lateNightUnit == null) {
//			// P =  * ԒP
//			lateNightUnit = new Float(getConfValueFloat(
//					aryRatioLateNight, uhIndividualDto.getPaymentType()) * amountPerHour);
//		}
//		if (attendanceMonthlyDto.getLateNight() > 0) {
//			// [蓖 = [鎞 * P
//			lateNightAllowance = attendanceMonthlyDto.getLateNight() * lateNightUnit.floatValue();
//		}
//		attendanceMonthlyDto.setLateNightUnit(lateNightUnit.floatValue());
//		attendanceMonthlyDto.setLateNightAllowance(
//				(int)round(lateNightAllowance, 0, BigDecimal.ROUND_CEILING));
//		// [cƎ蓖
//		double overLateAllowance = 0D;
//		if (attendanceMonthlyDto.getOverLate() > 0) {
//			// [蓖 = [鎞 * P
//			overLateAllowance = attendanceMonthlyDto.getOverLate() * effortUnit.floatValue();
//		}
//		attendanceMonthlyDto.setOverLateAllowance(
//				(int)round(overLateAllowance, 0, BigDecimal.ROUND_CEILING));
//		// xoΎ蓖
//		double holidayAllowance = 0D;
//		// 擾
//		Float holidayUnit = getUnitRatio(listUnitAmount, UnicConst.UNIT_WORK_ON_HOLIDAY);
//		// P݂Ȃꍇ
//		if (holidayUnit == null) {
//			// P =  * ԒP
//			holidayUnit = new Float(getConfValueFloat(
//					aryRatioWorkOnHoliday, uhIndividualDto.getPaymentType()) * amountPerHour);
//		}
//		if (attendanceMonthlyDto.getHolidayTime() > 0) {
//			// x蓖 = x * P
//			holidayAllowance = attendanceMonthlyDto.getHolidayTime() * holidayUnit.floatValue();
//		}
//		attendanceMonthlyDto.setHolidayUnit(holidayUnit.floatValue());
//		attendanceMonthlyDto.setHolidayAllowance(
//				(int)round(holidayAllowance, 0, BigDecimal.ROUND_CEILING));
//		// E[Ex
//		attendanceMonthlyDto.setOvertimeAllowance(
//				attendanceMonthlyDto.getEffortAllowance   () +
//				attendanceMonthlyDto.getLateNightAllowance() +
//				attendanceMonthlyDto.getOverLateAllowance () +
//				attendanceMonthlyDto.getHolidayAllowance  ()
//		);
//	}
//	
//	/**
//	 * P擾()
//	 * @return P()
//	 * @throws Exception
//	 */
//	private Float getUnitRatio(List<CmUnitAmountDto> listUnitAmount, String unitType) {
//		for (int i = 0; i < listUnitAmount.size(); i++) {
//			CmUnitAmountDto dto = listUnitAmount.get(i);
//			if (dto.getUnitType().equals(unitType)) {
//				return new Float((float)dto.getUnitAmount());
//			}
//		}
//		return null;
//	}
//	
//	/**
//	 * }{蓖ݒ肷B<br>
//	 * @throws Exception 
//	 */
//	private void setFamilyAllowance() throws Exception {
//		// }{蓖
//		attendanceMonthlyDto.setFamilyAllowance(0);
//		// }{ݒmF
//		UsDetailDto usDetailDto = mapPaymentDetail.get(UnicConst.DTL_PAY_ALLOWANCE_04);
//		if (usDetailDto == null) {
//			// ݒ肪ȂЈ0~
//			return;
//		}
//		// ГmF
//		if (uhBasisDto.getEntranceDate().compareTo(startDate) > 0) {
//			// x(ГvZ̏ꍇ)
//			return;
//		}
//		// ގГmF
//		if (uhBasisDto.getRetirementDate() != null) {
//			if (uhBasisDto.getRetirementDate().compareTo(endDate) < 0) {
//				// x(ގГvZŏIȌꍇ)
//				return;
//			}
//		}
//		// }{蓖xoΓ擾
//		if (familyAllowanceLimit == 0) {
//			familyAllowanceLimit =
//				(int)getConfValueDouble(UnicConst.CONF_ID_FAMILIY_LM, "");
//		}
//		// }{蓖xΓmF
//		if (attendanceMonthlyDto.getAbsence() > familyAllowanceLimit) {
//			// x(oΓ}{蓖xΓ葽ꍇ)
//			return;
//		}
//		// }{蓖Pݒ擾
//		if (mapFamilyAllowance == null) {
//			mapFamilyAllowance = getConfMap(UnicConst.CONF_ID_FAMILIY_AW);
//		}
//		// Ƒ(ی)擾
//		CmFamilyInsureDao dao = new CmFamilyInsureDao();
//		dao.initDao(cfg, cmd, aspUser, user, conn);
//		List<CmFamilyInsureDto> list = dao.findForEmployee(kCode);
//		// }{蓖ΏێҐ擾
//		int cntFamily = 0;
//		for (Iterator<CmFamilyInsureDto> it = list.iterator(); it.hasNext();) {
//			CmFamilyInsureDto dto = it.next();
//			// Nی}{Ҏi擾̏ꍇ
//			if (dto.getHeaQualifiedDate() == null) {
//				// }{蓖ΏۊO
//				continue;
//			}
//			// Nی}{Ҏi擾 > vZ
//			if (dto.getHeaQualifiedDate().compareTo(startDate) > 0) {
//				// }{蓖ΏۊO
//				continue;
//			}
//			// DL  D <= vZŏI
//			if (dto.getHeaDisqualifiedDate() != null &&
//					dto.getHeaDisqualifiedDate().compareTo(endDate) <= 0) {
//				// }{蓖ΏۊO
//				continue;
//			}
//			++cntFamily;
//		}
//		// }{蓖vZ
//		int familyAllowance = 0;
//		for (int i = 0; i < cntFamily; i++) {
//			// P擾
//			int unitAmount = 0;
//			String strAmount = mapFamilyAllowance.get(String.valueOf(i + 1));
//			if (strAmount == null) {
//				// 0̒Pp(Pݒ肪݂Ȃꍇ)
//				strAmount = mapFamilyAllowance.get(String.valueOf(0));
//			}
//			if (strAmount == null) {
//				unitAmount = 0;
//			} else {
//				unitAmount = Integer.parseInt(strAmount);
//			}
//			// }{蓖Z
//			familyAllowance += unitAmount;
//		}
//		// }{蓖ݒ
//		attendanceMonthlyDto.setFamilyAllowance(familyAllowance);
//	}
//	
//	/**
//	 * ʋΔݒ
//	 * @param listCommutation ʋΔ񃊃Xg
//	 */
//	private void setCmCommutationAmount(List<CmCommutationDto> listCommutation) {
//		// ϐ錾
//		int commuteAmount = 0;	// xʋΎ蓖
//		int monthlyAmount = 0;	// ʋΎ蓖
//		int monthlyTaxed  = 0;	// ېŒʋΔ
//		// ^擾
//		for (Iterator<CmCommutationDto> it = listCommutation.iterator(); it.hasNext();) {
//			// ϐ錾
//			int amount = 0    ;	// ʓʋΎ蓖
//			int taxed  = 0    ;	// ʓېŒʋΔ
//			// f[^擾
//			CmCommutationDto cmCommutationDto = it.next();
//			// ʋΎ蓖擾
//			if (cmCommutationDto.getPaymentInterval().equals("1")) {
//				// xԊuF
//				amount = cmCommutationDto.getCommuteAmount();
//				taxed  = cmCommutationDto.getCommuteTaxed ();
//				// ʋΎ蓖yѓېŒʋΔZ
//				monthlyAmount += amount;
//				monthlyTaxed  += taxed ;
//				// xʋΎ蓖Z
//				commuteAmount += amount;
//			} else if (cmCommutationDto.getPaymentInterval().equals("5")) {
//				// xԊuF(ʋΔ~oΓ(xo܂))
//				amount = cmCommutationDto.getCommuteAmount() * attendanceMonthlyDto.getPresenceAtt();
//				taxed  = cmCommutationDto.getCommuteTaxed () * attendanceMonthlyDto.getPresenceAtt();
//				// ʋΎ蓖yѓېŒʋΔZ
//				monthlyAmount += amount;
//				monthlyTaxed  += taxed ;
//				// xʋΎ蓖Z
//				commuteAmount += amount;
//			} else {
//				// xԊuF2A3A6
//				int interval     ;	// xԊu
//				int payStartMonth;	// xJn
//				int currentMonth ;	// vZΏی
//				// xԊu擾
//				if (cmCommutationDto.getPaymentInterval().equals("2")) {
//					interval = 2;
//				} else if (cmCommutationDto.getPaymentInterval().equals("3")) {
//					interval = 3;
//				} else {
//					interval = 6;
//				}
//				// xJn擾
//				payStartMonth = MospUtility.getMonth(cmCommutationDto.getPayStartMonth());
//				// vZΏی擾
//				currentMonth  = MospUtility.getMonth(targetMonth);
//				// ʓʋΎ蓖ݒ
//				amount = (int)round(
//						cmCommutationDto.getCommuteAmount() / (double)interval, 0, BigDecimal.ROUND_FLOOR);
//				// ʓېŒʋΔݒ
//				taxed  = (int)round(
//						cmCommutationDto.getCommuteTaxed () / (double)interval, 0, BigDecimal.ROUND_FLOOR);
//				// ʋΎ蓖xf
//				if (isAllowMonth(interval, payStartMonth, currentMonth)) {
//					// ʋΎ蓖AېŒʋΔĐݒ
//					amount += cmCommutationDto.getCommuteAmount() - amount * interval;
//					taxed  += cmCommutationDto.getCommuteTaxed () - taxed  * interval;
//				}
//				// ʋΎ蓖yѓېŒʋΔZ
//				monthlyAmount += amount;
//				monthlyTaxed  += taxed ;
//				// xʋΎ蓖Z
//				if (cmCommutationDto.getLumpMonthlyType().equals("1")) {
//					// ꊇ敪Fꊇ
//					if (isAllowMonth(interval, payStartMonth, currentMonth)) {
//						// x̏ꍇ
//						commuteAmount += cmCommutationDto.getCommuteAmount();
//					}
//				} else {
//					// ꊇ敪F
//					commuteAmount += amount;
//				}
//			}
//			// ʗpp҂̌xz߂ɂېŒʋΔ
//			// ېłȂ(Ǝdl)
//			/*
//			if (cmCommutationDto.getCommuteType().equals(UnicConst.COMMUTE_TYPE_CAR)) {
//				float distance = cmCommutationDto.getCommuteDistance();
//				// 2km̏ꍇ2kmƂ(Ǝdl)
//				distance = distance < 2F ? 2F : distance;
//				// ېŒʋΔ擾
//				monthlyTaxed += LegalUtility.getTaxationForCarCommute(
//						amount - taxed, distance);
//			}
//			*/
//		}
//		// ʋΎ蓖̌xz߂ɂېŒʋΔ
//		monthlyTaxed  += LegalUtility.getTaxationForCommutation(
//				monthlyAmount - monthlyTaxed);
//		// ^ݒ
//		attendanceMonthlyDto.setCommutation   (commuteAmount);
//		attendanceMonthlyDto.setCommutationTax(monthlyTaxed);
//	}
//	
//	/**
//	 * x
//	 * @param paymetInterval xԊu
//	 * @param payStartMonth  xJn
//	 * @param currentMonth   Ώی
//	 * @return x茋(trueFxAfalseFxłȂ)
//	 */
//	private boolean isAllowMonth(
//			int paymetInterval, int payStartMonth, int currentMonth
//	) {
//		int allowMonth = payStartMonth;
//		do {
//			allowMonth += paymetInterval;
//			if (12 < allowMonth) {
//				allowMonth -= 12;
//			}
//			if (currentMonth == allowMonth) {
//				return true;
//			}
//		} while (payStartMonth != allowMonth);
//		return false;
//	}
//	
//	/**
//	 * Љیݒ
//	 * @throws NoSuchFieldException 
//	 */
//	private void setSocialInsurance() throws SQLException, IllegalAccessException, NoSuchFieldException {
//		int health   = 0;	// Nی
//		int nursing  = 0;	// ی
//		int pension  = 0;	// N
//		int fund     = 0;	// N
//		int unemploy = 0;	// ٗpی
//		// l^(ی)擾
//		CmSocInsuranceDao dao = new CmSocInsuranceDao();
//		dao.initDao(cfg, cmd, aspUser, user, conn);
//		CmSocInsuranceDto dto = dao.findForEmployee(kCode, targetMonth);
//		// l^(ی)mF
//		if (dto == null) {
//			// Љیݒ
//			udPaymentDto.setHealthInsurance  (health  );
//			udPaymentDto.setNursingInsurance (nursing );
//			udPaymentDto.setPensionInsurance (pension );
//			udPaymentDto.setPensionFund      (fund    );
//			udPaymentDto.setEmployeeInsurance(unemploy);
//			return;
//		}
//		// ЉیvZ
//		if (dto.getCalcInsType().equals(LegalConst.CALC_INS)) {
//			// NیAیvZΏۊmF
//			if (dto.getHealthLostType().equals("")) {
//				// NیvZ
//				health = LegalUtility.calcPremium(dto.getHealthPayment(),
//						ratioHealthPremium, BigDecimal.ROUND_HALF_UP);
//				// یvZΏۊmF
//				if(chkCalcNursingInsType(dto.getNursingInsType())) {
//					// یvZ
//					nursing = LegalUtility.calcPremium(dto.getHealthPayment(),
//							ratioNursingPremium, BigDecimal.ROUND_HALF_UP);
//				}
//			}
//			// NANvZΏۊmF
//			if (dto.getPensionLostType().equals("")) {
//				// NvZ
//				pension = LegalUtility.calcPremium(dto.getPensionPayment(),
//						ratioPensionPremium, BigDecimal.ROUND_HALF_DOWN);
//				// NvZ(N敪uv̏ꍇ)
//				if (fundParticipation.equals(LegalConst.FUND_PARTICIPATION_ON)) {
//					fund = LegalUtility.calcPremium(dto.getPensionPayment(),
//							ratioFundPremium, BigDecimal.ROUND_HALF_UP);
//				}
//			}
//		}
//		// ٗpیvZ(ٗpی敪uvZv̏ꍇ)
//		if (dto.getCalcUnemployType().equals(LegalConst.CALC_UNEMPLOY)) {
//			// ٗpیvZΏۊmF
//			if (dto.getUnemployLostType().equals("")) {
//				unemploy = LegalUtility.calcPremium(
//						udPaymentDto.getAmountToSocIns(),
//						ratioUnemployPremium / 1000, BigDecimal.ROUND_HALF_DOWN);
//			}
//		}
//		// Љیݒ
//		udPaymentDto.setHealthInsurance  (health  );
//		udPaymentDto.setNursingInsurance (nursing );
//		udPaymentDto.setPensionInsurance (pension );
//		udPaymentDto.setPensionFund      (fund    );
//		udPaymentDto.setEmployeeInsurance(unemploy);
//	}
//	
//	/**
//	 * یvZΏۊmF
//	 * @param nursingInsType@ی敪
//	 * @return@vZΏۊmFtO
//	 * @throws SQLException
//	 * @throws IllegalAccessException
//	 * @throws NoSuchFieldException
//	 */
//	public boolean chkCalcNursingInsType(String nursingInsType) throws SQLException, IllegalAccessException, NoSuchFieldException {
//		boolean isCalc = false;
//		// یvZ(ی敪uΏ()v̏ꍇ)
//		if (nursingInsType.equals(LegalConst.NURSING_INS_AUTO)) {
//			// NŌvZΏۂf
//			isCalc = chkCalcNusingInsAuto();
//		}
//		// یvZ(ی敪uΏہv̏ꍇ)
//		if (nursingInsType.equals(LegalConst.NURSING_INS_MANUAL)) {
//			isCalc = true;
//		}
//		return isCalc;
//	}
//	
//	/**
//	 * یvZΏۊmF(敪FvZΏ())
//	 * @return vZΏۊmFtO
//	 * @throws SQLException
//	 * @throws IllegalAccessException
//	 * @throws NoSuchFieldException
//	 */
//	public boolean chkCalcNusingInsAuto() throws SQLException, IllegalAccessException, NoSuchFieldException {
//		// vZΏۊmFtO
//		boolean isCalc = false;
//		// DAO
//		UmExtraDao umExtraDao = new UmExtraDao();
//		umExtraDao.initDao(cfg, cmd, aspUser, user, conn);
//		// N擾
//		int age = 0;
//		// Ώ۔NŏI+1擾
//		Date targetDate = addDay(getEndDate(targetMonth), 1);
//		// Ǘ擾
//		UmExtraDto umExtraDto = umExtraDao.findForKey(kCode);
//		// Ǘf[^݂ȂЈ͑ΏۊO
//		if (umExtraDto == null) {
//			isCalc = false;
//			return isCalc;
//		}
//		// aݒ肳ĂȂЈ͑ΏۊO
//		if (umExtraDto.getBirthDate() == null) {
//			isCalc = false;
//			return isCalc;
//		}
//		// N擾(Ώ۔NŏI+1Ŕf)
//		age = getAge(umExtraDto.getBirthDate(), targetDate);
//		// 40Έȏ65Ζ͌vZΏ
//		if (age >= 40) {
//			isCalc = true;
//		}
//		if (age >= 65 ) {
//			isCalc = false;
//		}
//		return isCalc;
//		
//	}
	
	/**
	 * אݒɂzvZ(ېŊzyюЉیΏۊz)
	 * @throws NoSuchFieldException 
	 * @throws IllegalAccessException 
	 * @throws SQLException 
	 */
//	private void calcFreeAmount(
//	) throws SQLException, IllegalAccessException, NoSuchFieldException {
//		// 
//		taxFree    = 0;
//		socInsFree = 0;
//		// אݒ擾
//		Map<String, DetailPaDto > mapDetail = getMapDetail();
//		if (mapDetail == null) {
//			return;
//		}
//		// אݒ荀ږɊmF(KS18(ʋΔ)̓P[Xɂېŏς邽ߐݒ͖)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_01), udPaymentDto.getBasicSalary      ());	// ^Ex01(KS01)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_02), udPaymentDto.getAbility1Allowance());	// ^Ex02(KS02)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_03), udPaymentDto.getAbility2Allowance());	// ^Ex03(KS03)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_04), udPaymentDto.getFamilyAllowance  ());	// ^Ex04(KS04)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_05), udPaymentDto.getAllowance_05     ());	// ^Ex05(KS05)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_06), udPaymentDto.getAllowance_06     ());	// ^Ex06(KS06)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_07), udPaymentDto.getCutForMissing    ());	// ^Ex07(KS07)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_08), udPaymentDto.getCutForShort      ());	// ^Ex08(KS08)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_09), udPaymentDto.getAllowance_09     ());	// ^Ex09(KS09)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_10), udPaymentDto.getAllowance_10     ());	// ^Ex10(KS10)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_11), udPaymentDto.getAllowance_11     ());	// ^Ex11(KS11)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_12), udPaymentDto.getAllowance_12     ());	// ^Ex12(KS12)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_13), udPaymentDto.getAllowance_13     ());	// ^Ex13(KS13)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_14), udPaymentDto.getDateAllowance    ());	// ^Ex14(KS14)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_15), udPaymentDto.getAllowance_15     ());	// ^Ex15(KS15)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_16), udPaymentDto.getAllowance_16     ());	// ^Ex16(KS16)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_17), udPaymentDto.getAllowance_17     ());	// ^Ex17(KS17)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_19), udPaymentDto.getOvertimeAllowance());	// ^Ex19(KS20)
//		setFreeAmount(mapDetail.get(UnicConst.DTL_PAY_ALLOWANCE_20), udPaymentDto.getCutFromBasic     ());	// ^Ex20(KS20)
//	}
	
	/**
	 * אݒɂzݒ(ېŊzyюЉیΏۊz)
	 * @param detail       אݒDTO
	 * @param targetAmount Ώۋz
	 */
//	private void setFreeAmount(DetailPaDto detail, int targetAmount) {
//		// ݒvۊmF
//		if (targetAmount == 0 || detail == null) {
//			return;
//		}
//		// ېőΏۋ敪mF
//		if (detail.getTaxObjectType().equals(LegalConst.TAX_OBJECT_FREE)) {
//			if (detail.getTaxFreeUpperLimit() == 0) {
	// Szې
//				taxFree += targetAmount;
//			} else if (targetAmount > detail.getTaxFreeUpperLimit()) {
	// ېŏz܂ł͔ې(ېőΏۂ̏ꍇ)
//				taxFree += detail.getTaxFreeUpperLimit();
//			} else {
	// ɒBȂꍇ͑Szې
//				taxFree += targetAmount;
//			}
//		}
	// ЉیΏۋ敪mF
//		if (detail.getSocInsObjectType().equals(LegalConst.SOC_INS_OBJECT_FREE)) {
	// SzЉیΏ
//			socInsFree += targetAmount;
//		}
//	}
	
//	/**
//	 * ЉیlS擾
//	 * @throws SQLException
//	 * @throws IllegalAccessException
//	 * @throws NoSuchFieldException
//	 */
//	public void setSocInsRatio(
//	) throws SQLException, IllegalAccessException, NoSuchFieldException {
//		// 
//		ratioHealthPremium   = 0;	// Nی 
//		ratioNursingPremium  = 0;	// ی
//		ratioPensionPremium  = 0;	// N
//		ratioFundPremium     = 0;	// N
//		ratioUnemployPremium = 0;	// ٗpی
//		fundParticipation    = LegalConst.FUND_PARTICIPATION_OFF;	// N敪
//		// Џ擾
//		CmCompanyDao cmCompanyDao = new CmCompanyDao();
//		cmCompanyDao.initDao(cfg, cmd, aspUser, user, conn);
//		CmCompanyDto cmCompanyDto = cmCompanyDao.findAll();
//		if (cmCompanyDto == null) {
//			return;
//		}
//		// ЉیlS擾
//		ratioHealthPremium   = cmCompanyDto.getHealthPremiumRate  ();	// Nی  
//		ratioNursingPremium  = cmCompanyDto.getNursingPremiumRate ();	// ی
//		ratioPensionPremium  = cmCompanyDto.getPensionPremiumRate ();	// N
//		ratioFundPremium     = cmCompanyDto.getFundPremiumRate    ();	// N
//		ratioUnemployPremium = cmCompanyDto.getUnemployPremiumRate();	// ٗpی
//		fundParticipation    = cmCompanyDto.getFundParticipation  ();	// N敪
//	}
//	
//	/**
//	 * ZŐݒ
//	 * @throws IllegalAccessException 
//	 * @throws SQLException 
//	 * @throws NoSuchFieldException 
//	 */
//	public void setResidenceTax(
//	) throws SQLException, IllegalAccessException {
//		// l^(Z)擾
//		CmResidenceTaxDao dao = new CmResidenceTaxDao();
//		dao.initDao(cfg, cmd, aspUser, user, conn);
//		CmResidenceTaxDto dto = dao.findForEmployeeDate(kCode, targetMonth);
//		if (dto == null) {
//			udPaymentDto.setResidenceTax(0);
//			return;
//		}
//		// ΏیZŎ擾(Ώی+1)
//		int residenceTax = 0;
//		int month = MospUtility.getMonth(targetMonth) + 1;
//		if (month == 13) {
//			month = 1;
//		}
//		switch (month) {
//			case 6:
//				residenceTax = dto.getJuneAmount    ();
//				break;
//			case 7:
//				residenceTax = dto.getJulyAmount    ();
//				break;
//			case 8:
//				residenceTax = dto.getAugustAmount  ();
//				break;
//			case 9:
//				residenceTax = dto.getSeptemberAmount();
//				break;
//			case 10:
//				residenceTax = dto.getOctoberAmount ();
//				break;
//			case 11:
//				residenceTax = dto.getNovemberAmount();
//				break;
//			case 12:
//				residenceTax = dto.getDecemberAmount();
//				break;
//			case 1:
//				residenceTax = dto.getJanuaryAmount ();
//				break;
//			case 2:
//				residenceTax = dto.getFebruaryAmount();
//				break;
//			case 3:
//				residenceTax = dto.getMarchAmount   ();
//				break;
//			case 4:
//				residenceTax = dto.getAprilAmount   ();
//				break;
//			case 5:
//				residenceTax = dto.getMayAmount     ();
//				break;
//			default:
//				residenceTax = 0;
//		}
//		udPaymentDto.setResidenceTax(residenceTax);
//	}
	
	/**
	 * Őݒ
	 * @throws IllegalAccessException 
	 * @throws SQLException 
	 */
	public void setIncomeTax() throws SQLException, IllegalAccessException {
//		// l^()擾
//		CmIncomeTaxDao cmIncomeTaxDao = new CmIncomeTaxDao();
//		cmIncomeTaxDao.initDao(cfg, cmd, aspUser, user, conn);
//		CmIncomeTaxDto dto = cmIncomeTaxDao.findForEmployeeDate(kCode, targetMonth);
//		// l^()݂Ȃꍇ0ݒ
//		if (dto == null) {
//			// ŊzvZyѐݒ
//			udPaymentDto.setIncomeTax(0);
//			// }{̐ݒ
//			udPaymentDto.setDependentCount(0);
//			return;
//		}
//		// }{̐擾
//		int dependent = dto.getDependentCount();
//		// ېŋ敪擾
//		String incomeTaxType = dto.getIncomeTaxType();
//		// ЉیT̋^̋z擾
//		int taxation = udPaymentDto.getAmountToTaxation();
//		// ŊzvZyѐݒ
//		udPaymentDto.setIncomeTax(
//				LegalUtility.calcIncomeTax(incomeTaxType, taxation, dependent));
//		// }{̐ݒ
//		udPaymentDto.setDependentCount(dependent);
	}
	
	/**
	 * Őݒ(ܗ^)
	 * @throws Exception 
	 */
	public void setBonusIncomeTax() throws Exception {
//		// l^()擾
//		CmIncomeTaxDao cmIncomeTaxDao = new CmIncomeTaxDao();
//		cmIncomeTaxDao.initDao(cfg, cmd, aspUser, user, conn);
//		// ^擾
//		PhPaymentDao udPaymentDao = new PhPaymentDao();
//		udPaymentDao.initDao(cfg, cmd, aspUser, user, conn);
//		// ^xԊu擾(Ȃ1)
//		String interval = getConfValue(UnicConst.CONF_ID_PAY_ITBL, UnicConst.CONF_CD_ADJUST_PAY);
//		// Ώ۔N̑O̓t擾
//		befTargetMonth = addMonth(targetMonth, -1 - Integer.parseInt(interval));
//		CmIncomeTaxDto dto = cmIncomeTaxDao.findForEmployeeDate(kCode, befTargetMonth);
//		// l^()݂Ȃꍇ0ݒ
//		if (dto == null) {
//			// ŊzvZyѐݒ
//			udBonusDto.setIncomeTax(0);
//			// }{̐ݒ
//			udBonusDto.setDependentCount(0);
//			return;
//		}
//		// }{̐擾
//		int dependent = dto.getDependentCount();
//		// ېŋ敪擾
//		String incomeTaxType = dto.getIncomeTaxType();
//		udPaymentDto = udPaymentDao.findForUpdate(kCode, befTargetMonth);
//		// ЉیT̋^̋z擾
//		int payTaxation = udPaymentDto != null ? udPaymentDto.getAllowanceTotal() - udPaymentDto.calcSocialInsurance() : 0;
//		// ېőΏۊz(ܗ^)
//		int bonusTaxation = udBonusDto.calcBonusAllowanceTotal() - udBonusDto.calcBonusSocialInsurance();
//		// ŗ擾pz擾
//		double[] aryIncomeTax = LegalUtility.getBonIncomeTaxArray(incomeTaxType, dependent);
//		// ŗݒ
//		udBonusDto.setIncomeRate((float)LegalUtility.getBonusIncomeRate(aryIncomeTax, payTaxation));
//		
//		// ŊzvZyѐݒ
//		udBonusDto.setIncomeTax(
//				LegalUtility.calcBonusIncomeTax(incomeTaxType, payTaxation, bonusTaxation, dependent));
//		// }{̐ݒ
//		udBonusDto.setDependentCount(dependent);
//		// Ő^̋zݒ
//		udBonusDto.setLastMonthTaxation(payTaxation);
	}
	
//	/**
//	 * sU
//	 * @param total         xz
//	 * @param allowanceType x敪(1F^A2Fܗ^)
//	 * @throws SQLException
//	 * @throws IllegalAccessException
//	 * @throws NoSuchFieldException
//	 */
//	protected void divideAmongAccounts(
//			int total, String allowanceType
//	) throws SQLException, IllegalAccessException, NoSuchFieldException {
//		// 
//		bank1Amount = 0;
//		bank2Amount = 0;
//		cashAmount  = 0;
//		// DAO
//		CmPaymentMeansDao dao = new CmPaymentMeansDao();
//		dao.initDao(cfg, cmd, aspUser, user, conn);
//		// x@擾(x@Aԏ)
//		List<CmPaymentMeansDto> list;
//		list = dao.findForEmployeeAllowance(kCode, allowanceType);
//		// x񖈂̏
//		int currentAmount = total;
//		for (Iterator<CmPaymentMeansDto> it = list.iterator(); it.hasNext();) {
//			CmPaymentMeansDto dto = it.next();
//			// Uz擾
//			int amount = getdividedAmount(dto, total, currentAmount);
//			// Uzݒ
//			if (dto.getPaymentMeans().equals(UnicConst.PAYMENT_MEANS_ACCOUNT)) {
//				// Ȕꍇ
//				if (dto.getMeansSequence() == UnicConst.PAYMENT_MEANS_SEQ_1
//						|| dto.getMeansSequence() == UnicConst.PAYMENT_MEANS_SEQ_3) {
//					bank1Amount += amount;
//				} else {
//					bank2Amount += amount;
//				}
//			} else {
//				// UȊO()̏ꍇ
//				cashAmount += amount;
//			}
//			// czvZ
//			currentAmount -= amount;
//		}
//		// czɐݒ
//		cashAmount += currentAmount;
//	}
//	
//	/**
//	 * Uxz擾
//	 * @param dto           x@DTO
//	 * @param totalAmount   Uz
//	 * @param currentAmount Uz(cz)
//	 */
//	private int getdividedAmount(
//			CmPaymentMeansDto dto, int totalAmount, int currentAmount
//	) {
//		// x񂪐ݒ肳ĂȂꍇ
//		if (dto == null) {
//			return 0;
//		}
//		// Sz̏ꍇ
//		if (dto.getAmountType().equals(UnicConst.AMOUNT_TYPE_ALL)) {
//			return currentAmount;
//		}
//		// cz̏ꍇ
//		if (dto.getAmountType().equals(UnicConst.AMOUNT_TYPE_REST)) {
//			return currentAmount;
//		}
//		// Uxz
//		int dividingAmount = 0;
//		// z敪̏
//		if (dto.getAmountType().equals(UnicConst.AMOUNT_TYPE_AMOUNT)) {
//			// z̏ꍇ
//			dividingAmount = dto.getFixedAmount();
//		} else if (dto.getAmountType().equals(UnicConst.AMOUNT_TYPE_RATIO)) {
//			// 藦̏ꍇ
//			// Uz * U / 100
//			dividingAmount = (int)round(
//					dto.getFixedAmount() / 100 * totalAmount,
//					0, BigDecimal.ROUND_HALF_UP);
//		}
//		// Uzȏ̏ꍇ
//		if (dividingAmount > currentAmount) {
//			dividingAmount = currentAmount;
//		}
//		return dividingAmount;
//	}
	
	/**
	 * ^x̖אݒ擾B<br>
	 * @return אݒ
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException
	 */
	protected Map<String, DetailPaDto> getMapDetailPa() throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		List<DetailPaDto> listDetailAllPa;
		DetailPaDto dto;
		// אݒ擾
		if (mapDetailAllPa == null) {
			mapDetailAllPa = new HashMap<String, DetailPaDto>();
			PmDetailPaDao pmDetailPaDao = new PmDetailPaDao(cfg, cmd, aspUser, user, conn);
			listDetailAllPa = pmDetailPaDao.findAll();
			for (int i = 0; i < listDetailAllPa.size(); i++) {
				dto = listDetailAllPa.get(i);
				mapDetailAllPa.put(dto.getDetailCode(), dto);
			}
		}
		return mapDetailAllPa;
	}
	
	/**
	 * ^T̖אݒ擾B<br>
	 * @return אݒ
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException
	 */
	protected Map<String, DetailPdDto> getMapDetailPd() throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		List<DetailPdDto> listDetailAllPd;
		DetailPdDto dto;
		// אݒ擾
		if (mapDetailAllPd == null) {
			mapDetailAllPd = new HashMap<String, DetailPdDto>();
			PmDetailPdDao pmDetailPdDao = new PmDetailPdDao(cfg, cmd, aspUser, user, conn);
			listDetailAllPd = pmDetailPdDao.findAll();
			for (int i = 0; i < listDetailAllPd.size(); i++) {
				dto = listDetailAllPd.get(i);
				mapDetailAllPd.put(dto.getDetailCode(), dto);
			}
		}
		return mapDetailAllPd;
	}
	
	/**
	 * ^v̖אݒ擾B<br>
	 * @return אݒ
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException
	 */
	protected Map<String, DetailMoneyDto> getMapDetailPs() throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		// אݒ擾
		if (mapDetailAllPs == null) {
			PmDetailPsDao pmDetailPsDao = new PmDetailPsDao(cfg, cmd, aspUser, user, conn);
			List<DetailMoneyDto> listDetailAllPs = pmDetailPsDao.findAll();
			mapDetailAllPs = new HashMap<String, DetailMoneyDto>();
			for (int i = 0; i < listDetailAllPs.size(); i++) {
				DetailMoneyDto dto = listDetailAllPs.get(i);
				mapDetailAllPs.put(dto.getDetailCode(), dto);
			}
		}
		return mapDetailAllPs;
	}
	
	/**
	 * ^Αӕ̖אݒ擾B<br>
	 * @return אݒ
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException
	 */
	protected Map<String, DetailTimeDto> getMapDetailPt() throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		// אݒ擾
		if (mapDetailAllPt == null) {
			PmDetailPtDao pmDetailPtDao = new PmDetailPtDao(cfg, cmd, aspUser, user, conn);
			List<DetailTimeDto> listDetailAllPt = pmDetailPtDao.findAll();
			mapDetailAllPt = new HashMap<String, DetailTimeDto>();
			for (int i = 0; i < listDetailAllPt.size(); i++) {
				DetailTimeDto dto = listDetailAllPt.get(i);
				mapDetailAllPt.put(dto.getDetailCode(), dto);
			}
		}
		return mapDetailAllPt;
	}
	
	/**
	 * ܗ^x̖אݒ擾B<br>
	 * @return אݒ
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException
	 */
	protected Map<String, PmDetailBaDto> getMapDetailBa() throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		List<PmDetailBaDto> listDetailAllBa;
		// אݒ擾
		if (mapDetailAllBa == null) {
			mapDetailAllBa = new HashMap<String, PmDetailBaDto>();
			PmDetailBaDao pmDetailBaDao = new PmDetailBaDao(cfg, cmd, aspUser, user, conn);
			listDetailAllBa = pmDetailBaDao.findAll();
			for (int i = 0; i < listDetailAllBa.size(); i++) {
				PmDetailBaDto dto = listDetailAllBa.get(i);
				mapDetailAllBa.put(dto.getDetailCode(), dto);
			}
		}
		return mapDetailAllBa;
	}
	
	/**
	 * ܗ^T̖אݒ擾B<br>
	 * @return אݒ
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException
	 */
	protected Map<String, PmDetailBdDto> getMapDetailBd() throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		List<PmDetailBdDto> listDetailAllBd;
		// אݒ擾
		if (mapDetailAllBd == null) {
			mapDetailAllBd = new HashMap<String, PmDetailBdDto>();
			PmDetailBdDao pmDetailBdDao = new PmDetailBdDao(cfg, cmd, aspUser, user, conn);
			listDetailAllBd = pmDetailBdDao.findAll();
			for (int i = 0; i < listDetailAllBd.size(); i++) {
				PmDetailBdDto dto = listDetailAllBd.get(i);
				mapDetailAllBd.put(dto.getDetailCode(), dto);
			}
		}
		return mapDetailAllBd;
	}
	
	/**
	 * ܗ^v̖אݒ擾B<br>
	 * @return אݒ
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException
	 */
	protected Map<String, PmDetailBsDto> getMapDetailBs() throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		List<PmDetailBsDto> listDetailAllBs;
		// אݒ擾
		if (mapDetailAllBs == null) {
			mapDetailAllBs = new HashMap<String, PmDetailBsDto>();
			PmDetailBsDao pmDetailBsDao = new PmDetailBsDao(cfg, cmd, aspUser, user, conn);
			listDetailAllBs = pmDetailBsDao.findAll();
			for (int i = 0; i < listDetailAllBs.size(); i++) {
				PmDetailBsDto dto = listDetailAllBs.get(i);
				mapDetailAllBs.put(dto.getDetailCode(), dto);
			}
		}
		return mapDetailAllBs;
	}
	
	/**
	 * ^Axb擾
	 * @param targetKCode
	 * @param targetMonth
	 * @throws NoSuchFieldException 
	 * @throws IllegalAccessException 
	 * @throws SQLException 
	 * @throws MospException 
	 */
	public void calcPayBasicDate(String targetKCode, Date targetMonth) throws SQLException, IllegalAccessException,
			NoSuchFieldException, MospException {
		cdSocInsuranceDto = new CdSocInsuranceDto();
		
		//擾pTN𖢗ɐݒ
		Calendar tmpCal = Calendar.getInstance();
		tmpCal.set(2099, 12, 31, 0, 0, 0);
		oldHealthDate = oldNursingDate = oldoldPensionDate = oldFundDate = oldSocInsDate = tmpCal.getTime();
		
		oldHealthPremium = 0; // ^Nی
		oldNursingPremium = 0; // ^ی
		oldPensionPremium = 0; // ^Nی
		oldFundPremium = 0; // ^Nی
		oldSocInsPremium = 0; // ^Љیz
		
		// Ώ۔NȑO̓t擾
		int beforeYear4 = 0; //befor 4 month
		int beforeMonth4 = 0;
		int beforeYear3 = 0; //befor 3 month
		int beforeMonth3 = 0;
		int beforeYear2 = 0; //befor 2 month
		int beforeMonth2 = 0;
		int beforeYear1 = 0; //befor 1 month
		int beforeMonth1 = 0;
		
		//U
		beforeYear1 = MospUtility.getYear(targetMonth);
		beforeMonth1 = MospUtility.getMonth(targetMonth) - 1;
		if (beforeMonth1 == 0) {
			beforeMonth1 = 12;
			beforeYear1 = MospUtility.getYear(targetMonth) - 1;
		}
		//T
		beforeYear2 = beforeYear1;
		beforeMonth2 = beforeMonth1 - 1;
		if (beforeMonth2 == 0) {
			beforeMonth2 = 12;
			beforeYear2 = beforeYear1 - 1;
		}
		//S
		beforeYear3 = beforeYear2;
		beforeMonth3 = beforeMonth2 - 1;
		if (beforeMonth3 == 0) {
			beforeMonth3 = 12;
			beforeYear3 = beforeYear2 - 1;
		}
		//R
		beforeYear4 = beforeYear3;
		beforeMonth4 = beforeMonth3 - 1;
		if (beforeMonth4 == 0) {
			beforeMonth4 = 12;
			beforeYear4 = beforeYear3 - 1;
		}
		
		// xb()ݒ
		cdSocInsuranceDto.setPayBasicMonth1(beforeMonth1);
		cdSocInsuranceDto.setPayBasicMonth2(beforeMonth2);
		cdSocInsuranceDto.setPayBasicMonth3(beforeMonth3);
		
		// i~jO^擾
		oldPremium = getMonthlyPaymentData(targetKCode, beforeYear4, beforeMonth4);
		
		// Œ擾
		getBefFixedWage(targetKCode, beforeYear4, beforeMonth4);
		
		int payment1 = getMonthlyPaymentData(targetKCode, beforeYear1, beforeMonth1);
		// xb擾
		int payBasicDate1 = getPaymentBaiscDay(targetKCode, beforeYear1, beforeMonth1);
		// xb擾
		int payment2 = getMonthlyPaymentData(targetKCode, beforeYear2, beforeMonth2);
		// xb擾
		int payBasicDate2 = getPaymentBaiscDay(targetKCode, beforeYear2, beforeMonth2);
		// xb擾
		int payment3 = getMonthlyPaymentData(targetKCode, beforeYear3, beforeMonth3);
		// xb擾
		int payBasicDate3 = getPaymentBaiscDay(targetKCode, beforeYear3, beforeMonth3);
		// Œ擾
		getNowFixedWage(targetKCode, beforeYear3, beforeMonth3);
		
		// r
		CmMidwayEnterDao cmMidwayEnterDao = new CmMidwayEnterDao();
		cmMidwayEnterDao.initDao(cfg, cmd, aspUser, user, conn);
		CmMidwayEnterDto cmMidwayEnterDto;
		
		// vZΏێЈmF
		cmMidwayEnterDto = cmMidwayEnterDao.findForKey(targetKCode);
		if (cmMidwayEnterDto != null) {
			// rЂ͑ΏۂƂȂ
			if (cmMidwayEnterDto.getMidwayType().equals("1")) {
				if (MospUtility.getYear(DateUtil.convIntegerDateToDate(mKihonDto.getNyDate())) == beforeYear1
						&& MospUtility.getMonth(DateUtil.convIntegerDateToDate(mKihonDto.getNyDate())) == beforeMonth1) {
					payment1 = 0;
					payBasicDate1 = 0;
				}
				if (MospUtility.getYear(DateUtil.convIntegerDateToDate(mKihonDto.getNyDate())) == beforeYear2
						&& MospUtility.getMonth(DateUtil.convIntegerDateToDate(mKihonDto.getNyDate())) == beforeMonth2) {
					payment2 = 0;
					payBasicDate2 = 0;
				}
				if (MospUtility.getYear(DateUtil.convIntegerDateToDate(mKihonDto.getNyDate())) == beforeYear3
						&& MospUtility.getMonth(DateUtil.convIntegerDateToDate(mKihonDto.getNyDate())) == beforeMonth3) {
					payment2 = 0;
					payBasicDate2 = 0;
				}
			}
		}
		
		// ~擾
		if (befkotei != nowkotei) {
			// Œɍz
			cdSocInsuranceDto.setRaiseDownSalaryBasis(befkotei - nowkotei);
			Calendar cal1 = Calendar.getInstance();
			cal1.set(beforeYear4, beforeMonth4 - 1, PayrollConst.TIME_DEFAULT_DAY, 0, 0, 0);
			Date payBasicDate4 = cal1.getTime();
			cdSocInsuranceDto.setRaiseDownSalaryDate(payBasicDate4);
		}
		
		cdSocInsuranceDto.setPayAmount1(payment1);
		cdSocInsuranceDto.setPayBasicDay1(payBasicDate1);
		cdSocInsuranceDto.setPayAmount2(payment2);
		cdSocInsuranceDto.setPayBasicDay2(payBasicDate2);
		cdSocInsuranceDto.setPayAmount3(payment3);
		cdSocInsuranceDto.setPayBasicDay3(payBasicDate3);
		
		cdSocInsuranceDto.setRewardTotal1(payment1); // Vv1
		cdSocInsuranceDto.setRewardTotal2(payment2); // Vv2
		cdSocInsuranceDto.setRewardTotal3(payment3); // Vv3
		
		cdSocInsuranceDto.setHealthBefPremium(oldHealthPremium); // ۏ]Oی
		cdSocInsuranceDto.setPensionBefPremium(oldPensionPremium); // N]Oی
	}
	
	/**
	 * rOŒ擾
	 * @param targetKCode 
	 * @param targetYear 
	 * @param targetMonth 
	 * @throws NoSuchFieldException 
	 * @throws IllegalAccessException 
	 * @throws SQLException 
	 * @throws SQLException
	 * @throws NoSuchFieldException
	 * @throws IllegalAccessException
	 */
	public void getBefFixedWage(String targetKCode, int targetYear, int targetMonth) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		Date paymentDate;
		phSocInsPayment = new PhPaymentDto();
		Calendar cal1 = Calendar.getInstance();
		cal1.set(targetYear, targetMonth - 1, PayrollConst.TIME_DEFAULT_DAY, 0, 0, 0);
		paymentDate = cal1.getTime();
		PhPaymentDao phPaymentDao = new PhPaymentDao(cfg, cmd, aspUser, user, conn);
		phSocInsPayment = phPaymentDao.findForKey(targetKCode, paymentDate);
		pdPayAllowanceDao = new PdPayAllowanceDao(cfg, cmd, aspUser, user, conn);
		
		List<DetailMoneyDto> list = pdPayAllowanceDao.find(targetKCode, paymentDate);
		
		for (int i = 0; i < list.size(); i++) {
			befhikotei += list.get(i).getAmount();
		}
	}
	
	/**
	 * rŒ擾
	 * @param targetKCode 
	 * @param targetYear 
	 * @param targetMonth 
	 */
	public void getNowFixedWage(String targetKCode, int targetYear, int targetMonth) {
		// אݒe[u擾
//		UsDetailDao dao = new UsDetailDao();
//		dao.initDao(cfg, cmd, aspUser, user, conn);
//		List<DetailMoneyDto> list = dao.findForEmployeeAll(mKihonDto.getEmploymentType());
//
//	
//		nowkotei   = phSocInsPayment != null ? phSocInsPayment.getBasicSalary() : 0;
//		nowhikotei = phSocInsPayment != null ? phSocInsPayment.getOvertimeAllowance() : 0;
//		for (int i = 0; i < list.size(); i++) {
//			if (list.get(i).getSocInsObjectType().equals(LegalConst.SOC_INS_OBJECT_TAX) &&
//					list.get(i).getDetailCode().equals(PayrollConst.DTL_PAY_ATTENDANCE_13)) {
//				nowhikotei += phSocInsPayment.getAttendance_13();
//				continue;
//			} else if (list.get(i).getSocInsObjectType().equals(LegalConst.SOC_INS_OBJECT_TAX) &&
//					list.get(i).getDetailCode().equals(PayrollConst.DTL_PAY_ATTENDANCE_14)) {
//				nowhikotei += phSocInsPayment.getAttendance_14();
//				continue;
//			}
//		}
		
	}
	
	/**
	 * Vz擾
	 * @param targetKCode ΏێЈ
	 * @param targetYear Ώ۔N
	 * @param targetMonth Ώی
	 * @return@Vz
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException
	 * @throws MospException
	 */
	
	public int getMonthlyPaymentData(String targetKCode, int targetYear, int targetMonth) throws SQLException,
			IllegalAccessException, NoSuchFieldException, MospException {
		Date paymentDate;
		phSocInsPayment = new PhPaymentDto();
		Calendar cal1 = Calendar.getInstance();
		cal1.set(targetYear, targetMonth - 1, PayrollConst.TIME_DEFAULT_DAY, 0, 0, 0);
		paymentDate = cal1.getTime();
		PhPaymentDao phPaymentDao = new PhPaymentDao(cfg, cmd, aspUser, user, conn);
		phSocInsPayment = phPaymentDao.findForKey(targetKCode, paymentDate);
		pdPayAllowanceDao = new PdPayAllowanceDao(cfg, cmd, aspUser, user, conn);
		pdPayDeductionDao = new PdPayDeductionDao(cfg, cmd, aspUser, user, conn);
		DetailMoneyDto pdPayAllowanceDto = pdPayAllowanceDao.findDetailCode(targetKCode, paymentDate,
				PayrollConst.DTL_COMMUTATION);
		
		int commutation = 0; // ʋΎ蓖
		if (null != pdPayAllowanceDto) {
			commutation = pdPayAllowanceDto.getAmount();
		}
		
		int payment = 0;
		if (phSocInsPayment != null) {
			// xz - ʋΔ
			payment = phSocInsPayment.getAllowanceTotal() - commutation;
		} else {
			// ^擾G[
			String errMessage = MospUtility.getMessage(msg, "WU1121", targetYear + "," + targetMonth);
			addErrMessage(errMessage);
			throw new MospException(MospConst.EX_PARAMS_INVALID);
			
		}
		
		//^Nی
		DetailMoneyDto detailDeductionDto = pdPayDeductionDao.findDetailCode(targetKCode, paymentDate,
				PayrollConst.DTL_HEALTH_INS);
		if (null != detailDeductionDto) {
			if (paymentDate.before(oldHealthDate)) {
				oldHealthDate = paymentDate;
				oldHealthPremium = detailDeductionDto.getAmount();
			}
		}
		
		//^ی
		detailDeductionDto = pdPayDeductionDao.findDetailCode(targetKCode, paymentDate, PayrollConst.DTL_NURSING_INS);
		if (null != detailDeductionDto) {
			if (paymentDate.before(oldNursingDate)) {
				oldNursingDate = paymentDate;
				oldNursingPremium = detailDeductionDto.getAmount();
			}
		}
		
		//^Nی
		detailDeductionDto = pdPayDeductionDao.findDetailCode(targetKCode, paymentDate, PayrollConst.DTL_PENSION_INS);
		if (null != detailDeductionDto) {
			if (paymentDate.before(oldoldPensionDate)) {
				oldoldPensionDate = paymentDate;
				oldPensionPremium = detailDeductionDto.getAmount();
			}
		}
		
		//^Nی
		detailDeductionDto = pdPayDeductionDao.findDetailCode(targetKCode, paymentDate, PayrollConst.DTL_PENSION_FUND);
		if (null != detailDeductionDto) {
			if (paymentDate.before(oldFundDate)) {
				oldFundDate = paymentDate;
				oldFundPremium = detailDeductionDto.getAmount();
			}
		}
		
		//^Љیz
		detailDeductionDto = pdPayDeductionDao.findDetailCode(targetKCode, paymentDate, PayrollConst.DTL_PENSION_FUND);
		if (null != detailDeductionDto) {
			if (paymentDate.before(oldSocInsDate)) {
				oldSocInsDate = paymentDate;
				oldSocInsPremium = detailDeductionDto.getAmount();
			}
		}
		return payment;
	}
	
	/**
	 * xb擾
	 * @param targetKCode 
	 * @param year 
	 * @param month 
	 * @return
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	public int getPaymentBaiscDay(String targetKCode, int year, int month) throws SQLException, NoSuchFieldException,
			IllegalAccessException {
		int payBasicDate;
		DetailTimeDto detailTimeDto;
		Date paymentDate;
		Calendar cal1 = Calendar.getInstance();
		cal1.set(year, month, PayrollConst.TIME_DEFAULT_DAY, 0, 0, 0);
		paymentDate = cal1.getTime();
		PdPayTimeDao pdPayTimeDao = new PdPayTimeDao(cfg, cmd, aspUser, user, conn);
		
		//҂͊b
		if (mKihonDto.getKyKubun().equals(PayrollConst.PAYMENT_MONTH)) {
			detailTimeDto = pdPayTimeDao.findDetailCode(targetKCode, paymentDate, PayrollConst.DTL_PAY_TIME_12); // Γ擾
			float tmpKekkin = 0;
			if (null != detailTimeDto) {
				tmpKekkin = detailTimeDto.getAmount();
			}
			payBasicDate = calPayBasicDate(year, month); //xb
			//͊b|Γ
			payBasicDate -= tmpKekkin;
		} else if (mKihonDto.getKyKubun().equals(PayrollConst.PAYMENT_HOUR)) {
			detailTimeDto = pdPayTimeDao.findDetailCode(targetKCode, paymentDate, PayrollConst.DTL_PAY_TIME_01); // oΓ擾
			//҂͏oΓɂȂ
			payBasicDate = 0;
			if (null != detailTimeDto) {
				payBasicDate = (int)detailTimeDto.getAmount();
			}
		} else {
			detailTimeDto = pdPayTimeDao.findDetailCode(targetKCode, paymentDate, PayrollConst.DTL_PAY_TIME_12); // Γ擾
			int tmpKekkin = 0;
			if (null != detailTimeDto) {
				tmpKekkin = (int)detailTimeDto.getAmount();
			}
			payBasicDate = calPayBasicDate(year, month); //xb
			//͊b|Γ
			payBasicDate -= tmpKekkin;
			
			detailTimeDto = pdPayTimeDao.findDetailCode(targetKCode, paymentDate, PayrollConst.DTL_PAY_TIME_09); // Lx擾
			int tmpYukyu = 0;
			if (null != detailTimeDto) {
				tmpYukyu = (int)detailTimeDto.getAmount();
			}
			//҂͏oΓ{LxɂɂȂ
			payBasicDate += tmpYukyu;
		}
		return payBasicDate;
	}
	
	/**
	 * xb擾
	 * @param yy Ώ۔N
	 * @param mm Ώی
	 * @param dd Ώۓ
	 * @return
	 */
	public int calPayBasicDate(int year, int month) {
		//xb
		int retInt = 0;
		Date date = getLastDateOfMonth(String.valueOf(year), String.valueOf(month));
		// ̍ŏI擾
		retInt = MospUtility.getDay(date);
		return retInt;
	}
	
	/**
	 * WVz擾
	 * @param targetKCode ΏێЈ
	 * @param targetMonth Ώ۔N
	 * @throws SQLException@
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException 
	 */
	public void getStandardPayment(String targetKCode, Date targetMonth) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		// WVz擾
		int wdiv = 0;
		int whosyu = 0;
		int wHealthPayment = 0; //NیWVz
		int sPensionPayment = 0; //NWVz
		if (mKihonDto.getPtKubun().equals("1")) { //Ј
			if (cdSocInsuranceDto.getPayBasicDay1() >= 17) {
				wdiv += 1;
				whosyu += (cdSocInsuranceDto.getPayAmount1() + cdSocInsuranceDto.getGoodsAmount1());
			}
			if (cdSocInsuranceDto.getPayBasicDay2() >= 17) {
				wdiv += 1;
				whosyu += (cdSocInsuranceDto.getPayAmount2() + cdSocInsuranceDto.getGoodsAmount2());
			}
			if (cdSocInsuranceDto.getPayBasicDay3() >= 17) {
				wdiv += 1;
				whosyu += (cdSocInsuranceDto.getPayAmount3() + cdSocInsuranceDto.getGoodsAmount3());
			}
			// SĂ17B
			if (cdSocInsuranceDto.getPayBasicDay1() < 17 && cdSocInsuranceDto.getPayBasicDay2() < 17
					&& cdSocInsuranceDto.getPayBasicDay3() < 17) {
				if (cdSocInsuranceDto.getPayBasicDay1() >= 15) {
					wdiv += 1;
					whosyu += (cdSocInsuranceDto.getPayAmount1() + cdSocInsuranceDto.getGoodsAmount1());
				}
				if (cdSocInsuranceDto.getPayBasicDay1() >= 15) {
					wdiv += 1;
					whosyu += (cdSocInsuranceDto.getPayAmount2() + cdSocInsuranceDto.getGoodsAmount2());
				}
				if (cdSocInsuranceDto.getPayBasicDay3() >= 15) {
					wdiv += 1;
					whosyu += (cdSocInsuranceDto.getPayAmount3() + cdSocInsuranceDto.getGoodsAmount3());
				}
			}
		} else { //p[g
			//ЈƓlݒ
			if (cdSocInsuranceDto.getPayBasicDay1() >= 17) {
				wdiv += 1;
				whosyu += (cdSocInsuranceDto.getPayAmount1() + cdSocInsuranceDto.getGoodsAmount1());
			}
			if (cdSocInsuranceDto.getPayBasicDay2() >= 17) {
				wdiv += 1;
				whosyu += (cdSocInsuranceDto.getPayAmount2() + cdSocInsuranceDto.getGoodsAmount2());
			}
			if (cdSocInsuranceDto.getPayBasicDay3() >= 17) {
				wdiv += 1;
				whosyu += (cdSocInsuranceDto.getPayAmount3() + cdSocInsuranceDto.getGoodsAmount3());
			}
			// SĂ17B
			if (cdSocInsuranceDto.getPayBasicDay1() < 17 && cdSocInsuranceDto.getPayBasicDay2() < 17
					&& cdSocInsuranceDto.getPayBasicDay3() < 17) {
				if (cdSocInsuranceDto.getPayBasicDay1() >= 15) {
					wdiv += 1;
					whosyu += (cdSocInsuranceDto.getPayAmount1() + cdSocInsuranceDto.getGoodsAmount1());
				}
				if (cdSocInsuranceDto.getPayBasicDay1() >= 15) {
					wdiv += 1;
					whosyu += (cdSocInsuranceDto.getPayAmount2() + cdSocInsuranceDto.getGoodsAmount2());
				}
				if (cdSocInsuranceDto.getPayBasicDay3() >= 15) {
					wdiv += 1;
					whosyu += (cdSocInsuranceDto.getPayAmount3() + cdSocInsuranceDto.getGoodsAmount3());
				}
			}
		}
		
		int average;
		if (wdiv > 0) {
			average = whosyu / wdiv;
		} else {
			average = 0;
		}
		cdSocInsuranceDto.setAverageThreeMonths(average);
		cdSocInsuranceDto.setRewardTotalSum(whosyu);
		
		// WVz擾
		CmSocInsuranceDao cmSocInsuranceDao = new CmSocInsuranceDao();
		cmSocInsuranceDao.initDao(cfg, cmd, aspUser, user, conn);
		CmSocInsuranceDto cmSocInsuranceDto = cmSocInsuranceDao.findForEmployee(targetKCode);
		if (null != cmSocInsuranceDto) {
			wHealthPayment = cmSocInsuranceDto.getHealthPayment() * 1000; //NیWVz
			sPensionPayment = cmSocInsuranceDto.getPensionPayment() * 1000; //NWVz
		}
		
		//ۂ̓AWzV擾
		for (int i = 0; i < aryStandardPayment.length; i++) {
			if (wHealthPayment < aryPaymentUnder[i]) {
				cdSocInsuranceDto.setHealthBefGrade(arySocInsGrade[i]);
				cdSocInsuranceDto.setHealthBefPremium(aryStandardPayment[i]);
				break;
			}
		}
		
		//N̓AWzV擾
		for (int i = 0; i < aryStandardPayment.length; i++) {
			if (sPensionPayment < aryPaymentUnder[i]) {
				if (arySocInsGrade[i] - 4 < 0) {
					cdSocInsuranceDto.setPensionBefGrade(arySocInsGrade[i]);
				} else {
					cdSocInsuranceDto.setPensionBefGrade(arySocInsGrade[i] - 4);
				}
				cdSocInsuranceDto.setPensionBefPremium(aryStandardPayment[i]);
				break;
			}
		}
		
		// VAWVz擾
		for (int i = 0; i < aryPaymentOver.length; i++) {
			if (average < aryPaymentUnder[i]) {
				cdSocInsuranceDto.setHealthDecGrade(arySocInsGrade[i]);
				cdSocInsuranceDto.setHealthDecPremium(aryStandardPayment[i]);
				if (arySocInsGrade[i] - 4 < 0) {
					cdSocInsuranceDto.setPensionDecGrade(arySocInsGrade[i]);
				} else {
					cdSocInsuranceDto.setPensionDecGrade(arySocInsGrade[i] - 4);
				}
				cdSocInsuranceDto.setPensionDecPremium(aryStandardPayment[i]);
				break;
			}
		}
	}
	
	/**
	 * @param targetKCode
	 * @param year
	 * @return
	 * @throws SQLException
	 * @throws IllegalAccessException
	 * @throws NoSuchFieldException
	 * @throws MospException
	 */
	public boolean checkBonusCount(String targetKCode, String year) throws SQLException, IllegalAccessException,
			NoSuchFieldException, MospException {
		// NJn擾
		startDateOfYear = getStartDateOfYear(Integer.parseInt(year));
		// NŏI擾
		lastDateOfYear = getLastDateOfYear(Integer.parseInt(year));
		// ЈR[h擾
		kCode = targetKCode;
		
		// DAO
		PhBounsDao dao = new PhBounsDao(cfg, cmd, aspUser, user, conn);
		// Ώ۔N̏ܗ^f[^擾
		List<PhBounsDto> list = dao.findForPaydayOfYear(kCode, startDateOfYear, lastDateOfYear);
		
		// Ώ۔Ñf[^4ȏȂܗ^o^ɂ͂ȂȂ
		if (PayrollConst.UPPER_BONUS_REGIST <= list.size()) {
			// f[^쐬ΏۊȌꍇ̓G[
			String errMessage = MospUtility.getMessage(msg, PayrollConst.MSG_EXC_REG_BONUS, year
					+ PayrollConst.KEY_SEPARATOR + kCode);
			addErrMessage(errMessage);
			return false;
		}
		return true;
	}
	
	/**
	 * NJn擾
	 * @param year N
	 * @return NŏI
	 */
	protected Date getStartDateOfYear(int year) {
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.YEAR, year);
		cal.set(Calendar.MONTH, 0);
		cal.set(Calendar.DAY_OF_MONTH, 1);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		return cal.getTime();
	}
	
	/**
	 * NŏI擾
	 * @param year N
	 * @return NŏI
	 */
	protected Date getLastDateOfYear(int year) {
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.YEAR, year + 1);
		cal.set(Calendar.MONTH, 0);
		cal.set(Calendar.DAY_OF_MONTH, 1);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		cal.add(Calendar.DAY_OF_MONTH, -1);
		return cal.getTime();
	}
	
	/**
	 * 擾
	 * @param year  擾Ώ۔N
	 * @param month 擾Ώی
	 * @return 
	 */
	protected Date getFirstDateOfMonth(String year, String month) {
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.YEAR, Integer.parseInt(year));
		cal.set(Calendar.MONTH, Integer.parseInt(month) - 1);
		cal.set(Calendar.DAY_OF_MONTH, 1);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		return cal.getTime();
	}
	
	/**
	 * 
	 * @param date   t
	 * @param amount 
	 * @return t
	 */
	protected Date addMonth(Date date, int amount) {
		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		cal.add(Calendar.MONTH, amount);
		return cal.getTime();
	}
	
	/**
	 * N擾
	 * @param year  N
	 * @param month 
	 * @return N
	 */
	protected Date getYearMonth(String year, String month) {
		Calendar cal = Calendar.getInstance();
		cal.set(Integer.parseInt(year), Integer.parseInt(month) - 1, 1, 0, 0, 0);
		cal.set(Calendar.MILLISECOND, 0);
		return cal.getTime();
	}
	
	/**
	 * a擾
	 * @param list a񃊃Xg
	 * @param date t
	 * @return tz
	 * @throws MospException 
	 */
	public String[] getJpImperialCal(List<MosPConfDto> list, Date date) throws MospException {
		String[] aryJpDate = new String[4];
		if (date == null) {
			return aryJpDate;
		}
		for (MosPConfDto dto : list) {
			Date startDate = getDate(dto.getConfCode());
			Date endDate = getDate(dto.getConfValue());
			if (startDate.compareTo(date) <= 0 && endDate.compareTo(date) >= 0) {
				int year = MospUtility.getYear(date) - MospUtility.getYear(startDate) + 1;
				aryJpDate[0] = dto.getConfId();
				aryJpDate[1] = String.valueOf(year);
				aryJpDate[2] = String.valueOf(MospUtility.getMonth(date));
				aryJpDate[3] = String.valueOf(MospUtility.getDay(date));
				return aryJpDate;
			}
		}
		throw new MospException(MospConst.EX_DATE_INVALID);
	}
	
	/**
	 * t擾(/p)
	 * @param strDate t
	 * @return t
	 * @throws MospException 
	 */
	public Date getDate(String strDate) throws MospException {
		if (strDate == null || strDate.length() != 8) {
			throw new MospException(MospConst.EX_DATE_INVALID);
		}
		return MospUtility.getDate(strDate.substring(0, 4) + PayrollConst.SEPARATOR_DATE + strDate.substring(4, 6)
				+ PayrollConst.SEPARATOR_DATE + strDate.substring(6, 8));
	}
	
	/**
	 * VXet擾
	 * @return VXet
	 */
	@Override
	protected Date getSystemDate() {
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		return cal.getTime();
	}
	
	/**
	 * ŏI擾
	 * @param year  擾Ώ۔N
	 * @param month 擾Ώی
	 * @return ŏI
	 */
	protected Date getLastDateOfMonth(String year, String month) {
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.YEAR, Integer.parseInt(year));
		cal.set(Calendar.MONTH, Integer.parseInt(month));
		cal.set(Calendar.DAY_OF_MONTH, 1);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);
		cal.set(Calendar.MILLISECOND, 0);
		cal.add(Calendar.DAY_OF_MONTH, -1);
		return cal.getTime();
	}
	
	/**
	 * ̎擾
	 * @param code  擾ΏۃR[h
	 * @return R[h
	 */
	@Override
	protected String getCodeName(String code, String[][] array) {
		String codeName = code;
		if (array == null) {
			return codeName;
		}
		for (String[] element : array) {
			if (code.equals(element[0])) {
				codeName = element[1];
				break;
			}
		}
		return codeName;
	}
	
	/**
	 * N擾
	 * @param birthDay
	 * @param targetDay
	 * @return N
	 */
	protected int getAge(Date birthDay, Date targetDay) {
		// 擾
		int age = 0;
		// N擾
		age = MospUtility.getYear(targetDay) - MospUtility.getYear(birthDay);
		// Ώ۔NaNȂ0
		if (age < 0) {
			age = 0;
			return age;
		}
		// Ώیaȍ~
		if (MospUtility.getMonth(targetDay) - MospUtility.getMonth(birthDay) > 0) {
			return age;
		} else if (MospUtility.getMonth(targetDay) - MospUtility.getMonth(birthDay) == 0) {
			// Ώۓaȍ~
			if (MospUtility.getDay(targetDay) - MospUtility.getDay(birthDay) > 0) {
				return age;
			} else if (MospUtility.getDay(targetDay) - MospUtility.getDay(birthDay) == 0) {
				// Ώۓa
				return age;
			} else {
				// ΏۓaȑO
				return age - 1;
			}
		} else {
			// ΏیaȑO
			return age - 1;
		}
	}
	
	/**
	 * Nی擾
	 * @param intIn 擾Ώۂ̕Vz
	 * @return 
	 */
	public int getHealthDecGrade(int intIn) {
		int rtnNum = 0;
		// VAWVz擾
		for (int i = 0; i < aryPaymentOver.length; i++) {
			if (intIn < aryPaymentUnder[i]) {
				rtnNum = arySocInsGrade[i];
				break;
			}
		}
		return rtnNum;
	}
	
	/**
	 * N擾
	 * @param intIn 擾Ώۂ̕Vz
	 * @return 
	 */
	public int getPensionDecGrade(int intIn) {
		int rtnNum = 0;
		// VAWVz擾
		for (int i = 0; i < aryPaymentOver.length; i++) {
			if (intIn < aryPaymentUnder[i]) {
				if (arySocInsGrade[i] - 4 < 0) {
					rtnNum = arySocInsGrade[i];
				} else {
					rtnNum = arySocInsGrade[i] - 4;
				}
				break;
			}
		}
		return rtnNum;
		
	}
	
	/**
	 * NیWVz擾
	 * @param intIn 擾Ώۂ̕Vz
	 * @return 
	 */
	public int getHealthDecPremium(int intIn) {
		int rtnNum = 0;
		// VAWVz擾
		for (int i = 0; i < aryPaymentOver.length; i++) {
			if (intIn < aryPaymentUnder[i]) {
				rtnNum = aryStandardPayment[i];
				break;
				
			}
		}
		return rtnNum;
	}
	
	/**
	 * NWVz擾
	 * @param intIn 擾Ώۂ̕Vz
	 * @return 
	 */
	public int getPensionDecPremium(int intIn) {
		int rtnNum = 0;
		// VAWVz擾
		for (int i = 0; i < aryPaymentOver.length; i++) {
			if (intIn < aryPaymentUnder[i]) {
				rtnNum = aryStandardPayment[i];
				break;
			}
		}
		return rtnNum;
	}
	
	/**
	 * 
	 * @param prefecture ZR[h
	 * @return 
	 */
	public static String getPrefecture(int prefecture) {
		// 
		for (String[] element : aryPrefecture) {
			if (element[0].equals(String.valueOf(prefecture))) {
				return element[1];
			}
		}
		// ԎႢR[hԂ
		return aryPrefecture[0][1];
	}
}
